# coding: utf-8

# flake8: noqa

"""
    API Reference

      # Introduction  Welcome to the REST API reference for the Zuora Billing, Payments, and Central Platform!  To learn about the common use cases of Zuora REST APIs, check out the [REST API Tutorials](https://www.zuora.com/developer/rest-api/api-guides/overview/).  In addition to Zuora API Reference, we also provide API references for other Zuora products:    * [Revenue API Reference](https://www.zuora.com/developer/api-references/revenue/overview/)   * [Collections API Reference](https://www.zuora.com/developer/api-references/collections/overview/)      The Zuora REST API provides a broad set of operations and resources that:    * Enable Web Storefront integration from your website.   * Support self-service subscriber sign-ups and account management.   * Process revenue schedules through custom revenue rule models.   * Enable manipulation of most objects in the Zuora Billing Object Model.  Want to share your opinion on how our API works for you? <a href=\"https://community.zuora.com/t5/Developers/API-Feedback-Form/gpm-p/21399\" target=\"_blank\">Tell us how you feel </a>about using our API and what we can do to make it better.  Some of our older APIs are no longer recommended but still available, not affecting any existing integration. To find related API documentation, see [Older API Reference](https://www.zuora.com/developer/api-references/older-api/overview/).   ## Access to the API  If you have a Zuora tenant, you can access the Zuora REST API via one of the following endpoints:  | Tenant              | Base URL for REST Endpoints | |-------------------------|-------------------------| |US Cloud 1 Production | https://rest.na.zuora.com  | |US Cloud 1 API Sandbox |  https://rest.sandbox.na.zuora.com | |US Cloud 2 Production | https://rest.zuora.com | |US Cloud 2 API Sandbox | https://rest.apisandbox.zuora.com| |US Central Sandbox | https://rest.test.zuora.com |   |US Performance Test | https://rest.pt1.zuora.com | |US Production Copy | Submit a request at <a href=\"http://support.zuora.com/\" target=\"_blank\">Zuora Global Support</a> to enable the Zuora REST API in your tenant and obtain the base URL for REST endpoints. See [REST endpoint base URL of Production Copy (Service) Environment for existing and new customers](https://community.zuora.com/t5/API/REST-endpoint-base-URL-of-Production-Copy-Service-Environment/td-p/29611) for more information. | |EU Production | https://rest.eu.zuora.com | |EU API Sandbox | https://rest.sandbox.eu.zuora.com | |EU Central Sandbox | https://rest.test.eu.zuora.com |  The Production endpoint provides access to your live user data. Sandbox tenants are a good place to test code without affecting real-world data. If you would like Zuora to provision a Sandbox tenant for you, contact your Zuora representative for assistance.   If you do not have a Zuora tenant, go to <a href=\"https://www.zuora.com/resource/zuora-test-drive\" target=\"_blank\">https://www.zuora.com/resource/zuora-test-drive</a> and sign up for a Production Test Drive tenant. The tenant comes with seed data, including a sample product catalog.   # Error Handling  If a request to Zuora Billing REST API with an endpoint starting with `/v1` (except [Actions](https://www.zuora.com/developer/api-references/api/tag/Actions) and CRUD operations) fails, the response will contain an eight-digit error code with a corresponding error message to indicate the details of the error.  The following code snippet is a sample error response that contains an error code and message pair:  ```  {    \"success\": false,    \"processId\": \"CBCFED6580B4E076\",    \"reasons\":  [      {       \"code\": 53100320,       \"message\": \"'termType' value should be one of: TERMED, EVERGREEN\"      }     ]  } ``` The `success` field indicates whether the API request has succeeded. The `processId` field is a Zuora internal ID that you can provide to Zuora Global Support for troubleshooting purposes.  The `reasons` field contains the actual error code and message pair. The error code begins with `5` or `6` means that you encountered a certain issue that is specific to a REST API resource in Zuora Billing, Payments, and Central Platform. For example, `53100320` indicates that an invalid value is specified for the `termType` field of the `subscription` object.  The error code beginning with `9` usually indicates that an authentication-related issue occurred, and it can also indicate other unexpected errors depending on different cases. For example, `90000011` indicates that an invalid credential is provided in the request header.   When troubleshooting the error, you can divide the error code into two components: REST API resource code and error category code. See the following Zuora error code sample:  <a href=\"https://www.zuora.com/developer/images/ZuoraErrorCode.jpeg\" target=\"_blank\"><img src=\"https://www.zuora.com/developer/images/ZuoraErrorCode.jpeg\" alt=\"Zuora Error Code Sample\"></a>   **Note:** Zuora determines resource codes based on the request payload. Therefore, if GET and DELETE requests that do not contain payloads fail, you will get `500000` as the resource code, which indicates an unknown object and an unknown field.  The error category code of these requests is valid and follows the rules described in the [Error Category Codes](https://www.zuora.com/developer/api-references/api/overview/#section/Error-Handling/Error-Category-Codes) section.  In such case, you can refer to the returned error message to troubleshoot.   ## REST API Resource Codes  The 6-digit resource code indicates the REST API resource, typically a field of a Zuora object, on which the issue occurs. In the preceding example, `531003` refers to the `termType` field of the `subscription` object.   The value range for all REST API resource codes is from `500000` to `679999`. See <a href=\"https://knowledgecenter.zuora.com/Central_Platform/API/AA_REST_API/Resource_Codes\" target=\"_blank\">Resource Codes</a> in the Knowledge Center for a full list of resource codes.  ## Error Category Codes  The 2-digit error category code identifies the type of error, for example, resource not found or missing required field.   The following table describes all error categories and the corresponding resolution:  | Code    | Error category              | Description    | Resolution    | |:--------|:--------|:--------|:--------| | 10      | Permission or access denied | The request cannot be processed because a certain tenant or user permission is missing. | Check the missing tenant or user permission in the response message and contact <a href=\"https://support.zuora.com\" target=\"_blank\">Zuora Global Support</a> for enablement. | | 11      | Authentication failed       | Authentication fails due to invalid API authentication credentials. | Ensure that a valid API credential is specified. | | 20      | Invalid format or value     | The request cannot be processed due to an invalid field format or value. | Check the invalid field in the error message, and ensure that the format and value of all fields you passed in are valid. | | 21      | Unknown field in request    | The request cannot be processed because an unknown field exists in the request body. | Check the unknown field name in the response message, and ensure that you do not include any unknown field in the request body. | | 22      | Missing required field      | The request cannot be processed because a required field in the request body is missing. | Check the missing field name in the response message, and ensure that you include all required fields in the request body. | | 23      | Missing required parameter  | The request cannot be processed because a required query parameter is missing. | Check the missing parameter name in the response message, and ensure that you include the parameter in the query. | | 30      | Rule restriction            | The request cannot be processed due to the violation of a Zuora business rule. | Check the response message and ensure that the API request meets the specified business rules. | | 40      | Not found                   | The specified resource cannot be found. | Check the response message and ensure that the specified resource exists in your Zuora tenant. | | 45      | Unsupported request         | The requested endpoint does not support the specified HTTP method. | Check your request and ensure that the endpoint and method matches. | | 50      | Locking contention          | This request cannot be processed because the objects this request is trying to modify are being modified by another API request, UI operation, or batch job process. | <p>Resubmit the request first to have another try.</p> <p>If this error still occurs, contact <a href=\"https://support.zuora.com\" target=\"_blank\">Zuora Global Support</a> with the returned `Zuora-Request-Id` value in the response header for assistance.</p> | | 60      | Internal error              | The server encounters an internal error. | Contact <a href=\"https://support.zuora.com\" target=\"_blank\">Zuora Global Support</a> with the returned `Zuora-Request-Id` value in the response header for assistance. | | 61      | Temporary error             | A temporary error occurs during request processing, for example, a database communication error. | <p>Resubmit the request first to have another try.</p> <p>If this error still occurs, contact <a href=\"https://support.zuora.com\" target=\"_blank\">Zuora Global Support</a> with the returned `Zuora-Request-Id` value in the response header for assistance. </p>| | 70      | Request exceeded limit      | The total number of concurrent requests exceeds the limit allowed by the system. | <p>Resubmit the request after the number of seconds specified by the `Retry-After` value in the response header.</p> <p>Check [Concurrent request limits](https://www.zuora.com/developer/rest-api/general-concepts/rate-concurrency-limits/) for details about Zuora’s concurrent request limit policy.</p> | | 90      | Malformed request           | The request cannot be processed due to JSON syntax errors. | Check the syntax error in the JSON request body and ensure that the request is in the correct JSON format. | | 99      | Integration error           | The server encounters an error when communicating with an external system, for example, payment gateway, tax engine provider. | Check the response message and take action accordingly. |   # API Versions  The Zuora REST API are version controlled. Versioning ensures that Zuora REST API changes are backward compatible. Zuora uses a major and minor version nomenclature to manage changes. By specifying a version in a REST request, you can get expected responses regardless of future changes to the API.  ## Major Version  The major version number of the REST API appears in the REST URL. In this API reference, only the **v1** major version is available. For example, `POST https://rest.zuora.com/v1/subscriptions`.  ## Minor Version  Zuora uses minor versions for the REST API to control small changes. For example, a field in a REST method is deprecated and a new field is used to replace it.   Some fields in the REST methods are supported as of minor versions. If a field is not noted with a minor version, this field is available for all minor versions. If a field is noted with a minor version, this field is in version control. You must specify the supported minor version in the request header to process without an error.   If a field is in version control, it is either with a minimum minor version or a maximum minor version, or both of them. You can only use this field with the minor version between the minimum and the maximum minor versions. For example, the `invoiceCollect` field in the POST Subscription method is in version control and its maximum minor version is 189.0. You can only use this field with the minor version 189.0 or earlier.  If you specify a version number in the request header that is not supported, Zuora will use the minimum minor version of the REST API. In our REST API documentation, if a field or feature requires a minor version number, we note that in the field description.  You only need to specify the version number when you use the fields require a minor version. To specify the minor version, set the `zuora-version` parameter to the minor version number in the request header for the request call. For example, the `collect` field is in 196.0 minor version. If you want to use this field for the POST Subscription method, set the  `zuora-version` parameter to `196.0` in the request header. The `zuora-version` parameter is case sensitive.  For all the REST API fields, by default, if the minor version is not specified in the request header, Zuora will use the minimum minor version of the REST API to avoid breaking your integration.   ### Minor Version History  The supported minor versions are not serial. This section documents the changes made to each Zuora REST API minor version.  The following table lists the supported versions and the fields that have a Zuora REST API minor version.  | Fields         | Minor Version      | REST Methods    | Description | |:--------|:--------|:--------|:--------| | invoiceCollect | 189.0 and earlier  | [Create Subscription](https://www.zuora.com/developer/api-references/api/operation/POST_Subscription \"Create Subscription\"); [Update Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_Subscription \"Update Subscription\"); [Renew Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_RenewSubscription \"Renew Subscription\"); [Cancel Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_CancelSubscription \"Cancel Subscription\"); [Suspend Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_SuspendSubscription \"Suspend Subscription\"); [Resume Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_ResumeSubscription \"Resume Subscription\"); [Create Account](https://www.zuora.com/developer/api-references/api/operation/POST_Account \"Create Account\")|Generates an invoice and collects a payment for a subscription. | | collect        | 196.0 and later    | [Create Subscription](https://www.zuora.com/developer/api-references/api/operation/POST_Subscription \"Create Subscription\"); [Update Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_Subscription \"Update Subscription\"); [Renew Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_RenewSubscription \"Renew Subscription\"); [Cancel Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_CancelSubscription \"Cancel Subscription\"); [Suspend Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_SuspendSubscription \"Suspend Subscription\"); [Resume Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_ResumeSubscription \"Resume Subscription\"); [Create Account](https://www.zuora.com/developer/api-references/api/operation/POST_Account \"Create Account\")|Collects an automatic payment for a subscription. | | invoice | 196.0 and 207.0| [Create Subscription](https://www.zuora.com/developer/api-references/api/operation/POST_Subscription \"Create Subscription\"); [Update Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_Subscription \"Update Subscription\"); [Renew Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_RenewSubscription \"Renew Subscription\"); [Cancel Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_CancelSubscription \"Cancel Subscription\"); [Suspend Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_SuspendSubscription \"Suspend Subscription\"); [Resume Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_ResumeSubscription \"Resume Subscription\"); [Create Account](https://www.zuora.com/developer/api-references/api/operation/POST_Account \"Create Account\")|Generates an invoice for a subscription. | | invoiceTargetDate | 206.0 and earlier  | [Preview Subscription](https://www.zuora.com/developer/api-references/api/operation/POST_PreviewSubscription \"Preview Subscription\") |Date through which charges are calculated on the invoice, as `yyyy-mm-dd`. | | invoiceTargetDate | 207.0 and earlier  | [Create Subscription](https://www.zuora.com/developer/api-references/api/operation/POST_Subscription \"Create Subscription\"); [Update Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_Subscription \"Update Subscription\"); [Renew Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_RenewSubscription \"Renew Subscription\"); [Cancel Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_CancelSubscription \"Cancel Subscription\"); [Suspend Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_SuspendSubscription \"Suspend Subscription\"); [Resume Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_ResumeSubscription \"Resume Subscription\"); [Create Account](https://www.zuora.com/developer/api-references/api/operation/POST_Account \"Create Account\")|Date through which charges are calculated on the invoice, as `yyyy-mm-dd`. | | targetDate | 207.0 and later | [Preview Subscription](https://www.zuora.com/developer/api-references/api/operation/POST_PreviewSubscription \"Preview Subscription\") |Date through which charges are calculated on the invoice, as `yyyy-mm-dd`. | | targetDate | 211.0 and later | [Create Subscription](https://www.zuora.com/developer/api-references/api/operation/POST_Subscription \"Create Subscription\"); [Update Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_Subscription \"Update Subscription\"); [Renew Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_RenewSubscription \"Renew Subscription\"); [Cancel Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_CancelSubscription \"Cancel Subscription\"); [Suspend Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_SuspendSubscription \"Suspend Subscription\"); [Resume Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_ResumeSubscription \"Resume Subscription\"); [Create Account](https://www.zuora.com/developer/api-references/api/operation/POST_Account \"Create Account\")|Date through which charges are calculated on the invoice, as `yyyy-mm-dd`. | | includeExisting DraftInvoiceItems | 206.0 and earlier| [Preview Subscription](https://www.zuora.com/developer/api-references/api/operation/POST_PreviewSubscription \"Preview Subscription\"); [Update Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_Subscription \"Update Subscription\") | Specifies whether to include draft invoice items in subscription previews. Specify it to be `true` (default) to include draft invoice items in the preview result. Specify it to be `false` to excludes draft invoice items in the preview result. | | includeExisting DraftDocItems | 207.0 and later  | [Preview Subscription](https://www.zuora.com/developer/api-references/api/operation/POST_PreviewSubscription \"Preview Subscription\"); [Update Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_Subscription \"Update Subscription\") | Specifies whether to include draft invoice items in subscription previews. Specify it to be `true` (default) to include draft invoice items in the preview result. Specify it to be `false` to excludes draft invoice items in the preview result. | | previewType | 206.0 and earlier| [Preview Subscription](https://www.zuora.com/developer/api-references/api/operation/POST_PreviewSubscription \"Preview Subscription\"); [Update Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_Subscription \"Update Subscription\") | The type of preview you will receive. The possible values are `InvoiceItem`(default), `ChargeMetrics`, and `InvoiceItemChargeMetrics`. | | previewType | 207.0 and later  | [Preview Subscription](https://www.zuora.com/developer/api-references/api/operation/POST_PreviewSubscription \"Preview Subscription\"); [Update Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_Subscription \"Update Subscription\") | The type of preview you will receive. The possible values are `LegalDoc`(default), `ChargeMetrics`, and `LegalDocChargeMetrics`. | | runBilling  | 211.0 and later  | [Create Subscription](https://www.zuora.com/developer/api-references/api/operation/POST_Subscription \"Create Subscription\"); [Update Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_Subscription \"Update Subscription\"); [Renew Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_RenewSubscription \"Renew Subscription\"); [Cancel Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_CancelSubscription \"Cancel Subscription\"); [Suspend Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_SuspendSubscription \"Suspend Subscription\"); [Resume Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_ResumeSubscription \"Resume Subscription\"); [Create Account](https://www.zuora.com/developer/api-references/api/operation/POST_Account \"Create Account\")|Generates an invoice or credit memo for a subscription. **Note:** Credit memos are only available if you have the Invoice Settlement feature enabled. | | invoiceDate | 214.0 and earlier  | [Invoice and Collect](https://www.zuora.com/developer/api-references/api/operation/POST_TransactionInvoicePayment \"Invoice and Collect\") |Date that should appear on the invoice being generated, as `yyyy-mm-dd`. | | invoiceTargetDate | 214.0 and earlier  | [Invoice and Collect](https://www.zuora.com/developer/api-references/api/operation/POST_TransactionInvoicePayment \"Invoice and Collect\") |Date through which to calculate charges on this account if an invoice is generated, as `yyyy-mm-dd`. | | documentDate | 215.0 and later | [Invoice and Collect](https://www.zuora.com/developer/api-references/api/operation/POST_TransactionInvoicePayment \"Invoice and Collect\") |Date that should appear on the invoice and credit memo being generated, as `yyyy-mm-dd`. | | targetDate | 215.0 and later | [Invoice and Collect](https://www.zuora.com/developer/api-references/api/operation/POST_TransactionInvoicePayment \"Invoice and Collect\") |Date through which to calculate charges on this account if an invoice or a credit memo is generated, as `yyyy-mm-dd`. | | memoItemAmount | 223.0 and earlier | [Create credit memo from charge](https://www.zuora.com/developer/api-references/api/operation/POST_CreditMemoFromPrpc \"Create credit memo from charge\"); [Create debit memo from charge](https://www.zuora.com/developer/api-references/api/operation/POST_DebitMemoFromPrpc \"Create debit memo from charge\") | Amount of the memo item. | | amount | 224.0 and later | [Create credit memo from charge](https://www.zuora.com/developer/api-references/api/operation/POST_CreditMemoFromPrpc \"Create credit memo from charge\"); [Create debit memo from charge](https://www.zuora.com/developer/api-references/api/operation/POST_DebitMemoFromPrpc \"Create debit memo from charge\") | Amount of the memo item. | | subscriptionNumbers | 222.4 and earlier | [Create order](https://www.zuora.com/developer/api-references/api/operation/POST_Order \"Create order\") | Container for the subscription numbers of the subscriptions in an order. | | subscriptions | 223.0 and later | [Create order](https://www.zuora.com/developer/api-references/api/operation/POST_Order \"Create order\") | Container for the subscription numbers and statuses in an order. | | creditTaxItems | 238.0 and earlier | [Get credit memo items](https://www.zuora.com/developer/api-references/api/operation/GET_CreditMemoItems \"Get credit memo items\"); [Get credit memo item](https://www.zuora.com/developer/api-references/api/operation/GET_CreditMemoItem \"Get credit memo item\") | Container for the taxation items of the credit memo item. | | taxItems | 238.0 and earlier | [Get debit memo items](https://www.zuora.com/developer/api-references/api/operation/GET_DebitMemoItems \"Get debit memo items\"); [Get debit memo item](https://www.zuora.com/developer/api-references/api/operation/GET_DebitMemoItem \"Get debit memo item\") | Container for the taxation items of the debit memo item. | | taxationItems | 239.0 and later | [Get credit memo items](https://www.zuora.com/developer/api-references/api/operation/GET_CreditMemoItems \"Get credit memo items\"); [Get credit memo item](https://www.zuora.com/developer/api-references/api/operation/GET_CreditMemoItem \"Get credit memo item\"); [Get debit memo items](https://www.zuora.com/developer/api-references/api/operation/GET_DebitMemoItems \"Get debit memo items\"); [Get debit memo item](https://www.zuora.com/developer/api-references/api/operation/GET_DebitMemoItem \"Get debit memo item\") | Container for the taxation items of the memo item. | | chargeId | 256.0 and earlier | [Create credit memo from charge](https://www.zuora.com/developer/api-references/api/operation/POST_CreditMemoFromPrpc \"Create credit memo from charge\"); [Create debit memo from charge](https://www.zuora.com/developer/api-references/api/operation/POST_DebitMemoFromPrpc \"Create debit memo from charge\") | ID of the product rate plan charge that the memo is created from. | | productRatePlanChargeId | 257.0 and later | [Create credit memo from charge](https://www.zuora.com/developer/api-references/api/operation/POST_CreditMemoFromPrpc \"Create credit memo from charge\"); [Create debit memo from charge](https://www.zuora.com/developer/api-references/api/operation/POST_DebitMemoFromPrpc \"Create debit memo from charge\") | ID of the product rate plan charge that the memo is created from. | | comment | 256.0 and earlier | [Create credit memo from charge](https://www.zuora.com/developer/api-references/api/operation/POST_CreditMemoFromPrpc \"Create credit memo from charge\"); [Create debit memo from charge](https://www.zuora.com/developer/api-references/api/operation/POST_DebitMemoFromPrpc \"Create debit memo from charge\"); [Create credit memo from invoice](https://www.zuora.com/developer/api-references/api/operation/POST_CreditMemoFromInvoice \"Create credit memo from invoice\"); [Create debit memo from invoice](https://www.zuora.com/developer/api-references/api/operation/POST_DebitMemoFromInvoice \"Create debit memo from invoice\"); [Get credit memo items](https://www.zuora.com/developer/api-references/api/operation/GET_CreditMemoItems \"Get credit memo items\"); [Get credit memo item](https://www.zuora.com/developer/api-references/api/operation/GET_CreditMemoItem \"Get credit memo item\"); [Get debit memo items](https://www.zuora.com/developer/api-references/api/operation/GET_DebitMemoItems \"Get debit memo items\"); [Get debit memo item](https://www.zuora.com/developer/api-references/api/operation/GET_DebitMemoItem \"Get debit memo item\") | Comments about the product rate plan charge, invoice item, or memo item. | | description | 257.0 and later | [Create credit memo from charge](https://www.zuora.com/developer/api-references/api/operation/POST_CreditMemoFromPrpc \"Create credit memo from charge\"); [Create debit memo from charge](https://www.zuora.com/developer/api-references/api/operation/POST_DebitMemoFromPrpc \"Create debit memo from charge\"); [Create credit memo from invoice](https://www.zuora.com/developer/api-references/api/operation/POST_CreditMemoFromInvoice \"Create credit memo from invoice\"); [Create debit memo from invoice](https://www.zuora.com/developer/api-references/api/operation/POST_DebitMemoFromInvoice \"Create debit memo from invoice\"); [Get credit memo items](https://www.zuora.com/developer/api-references/api/operation/GET_CreditMemoItems \"Get credit memo items\"); [Get credit memo item](https://www.zuora.com/developer/api-references/api/operation/GET_CreditMemoItem \"Get credit memo item\"); [Get debit memo items](https://www.zuora.com/developer/api-references/api/operation/GET_DebitMemoItems \"Get debit memo items\"); [Get debit memo item](https://www.zuora.com/developer/api-references/api/operation/GET_DebitMemoItem \"Get debit memo item\") | Description of the the product rate plan charge, invoice item, or memo item. | | taxationItems | 309.0 and later | [Preview an order](https://www.zuora.com/developer/api-references/api/operation/POST_PreviewOrder \"Preview an order\") | List of taxation items for an invoice item or a credit memo item. | | batch | 309.0 and earlier | [Create a billing preview run](https://www.zuora.com/developer/api-references/api/operation/POST_BillingPreviewRun \"Create a billing preview run\") | The customer batches to include in the billing preview run. |       | batches | 314.0 and later | [Create a billing preview run](https://www.zuora.com/developer/api-references/api/operation/POST_BillingPreviewRun \"Create a billing preview run\") | The customer batches to include in the billing preview run. | | taxationItems | 315.0 and later | [Preview a subscription](https://www.zuora.com/developer/api-references/api/operation/POST_PreviewSubscription \"Preview a subscription\"); [Update a subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_Subscription \"Update a subscription\")| List of taxation items for an invoice item or a credit memo item. | | billingDocument | 330.0 and later | [Create a payment schedule](https://www.zuora.com/developer/api-references/api/operation/POST_PaymentSchedule \"Create a payment schedule\"); [Create multiple payment schedules at once](https://www.zuora.com/developer/api-references/api/operation/POST_PaymentSchedules \"Create multiple payment schedules at once\")| The billing document with which the payment schedule item is associated. | | paymentId | 336.0 and earlier | [Add payment schedule items to a custom payment schedule](https://www.zuora.com/developer/api-references/api/operation/POST_AddItemsToCustomPaymentSchedule/ \"Add payment schedule items to a custom payment schedule\"); [Update a payment schedule](https://www.zuora.com/developer/api-references/api/operation/PUT_PaymentSchedule/ \"Update a payment schedule\"); [Update a payment schedule item](https://www.zuora.com/developer/api-references/api/operation/PUT_PaymentScheduleItem/ \"Update a payment schedule item\"); [Preview the result of payment schedule update](https://www.zuora.com/developer/api-references/api/operation/PUT_PaymentScheduleUpdatePreview/ \"Preview the result of payment schedule update\"); [Retrieve a payment schedule](https://www.zuora.com/developer/api-references/api/operation/GET_PaymentSchedule/ \"Retrieve a payment schedule\"); [Retrieve a payment schedule item](https://www.zuora.com/developer/api-references/api/operation/GET_PaymentScheduleItem/ \"Retrieve a payment schedule item\"); [List payment schedules by customer account](https://www.zuora.com/developer/api-references/api/operation/GET_PaymentSchedules/ \"List payment schedules by customer account\"); [Cancel a payment schedule](https://www.zuora.com/developer/api-references/api/operation/PUT_CancelPaymentSchedule/ \"Cancel a payment schedule\"); [Cancel a payment schedule item](https://www.zuora.com/developer/api-references/api/operation/PUT_CancelPaymentScheduleItem/ \"Cancel a payment schedule item\");[Skip a payment schedule item](https://www.zuora.com/developer/api-references/api/operation/PUT_SkipPaymentScheduleItem/ \"Skip a payment schedule item\");[Retry failed payment schedule items](https://www.zuora.com/developer/api-references/api/operation/POST_RetryPaymentScheduleItem/ \"Retry failed payment schedule items\") | ID of the payment to be linked to the payment schedule item. | | paymentOption | 337.0 and later | [Create a payment schedule](https://www.zuora.com/developer/api-references/api/operation/POST_PaymentSchedule/ \"Create a payment schedule\"); [Create multiple payment schedules at once](https://www.zuora.com/developer/api-references/api/operation/POST_PaymentSchedules/ \"Create multiple payment schedules at once\"); [Create a payment](https://www.zuora.com/developer/api-references/api/operation/POST_CreatePayment/ \"Create a payment\"); [Add payment schedule items to a custom payment schedule](https://www.zuora.com/developer/api-references/api/operation/POST_AddItemsToCustomPaymentSchedule/ \"Add payment schedule items to a custom payment schedule\"); [Update a payment schedule](https://www.zuora.com/developer/api-references/api/operation/PUT_PaymentSchedule/ \"Update a payment schedule\"); [Update a payment schedule item](https://www.zuora.com/developer/api-references/api/operation/PUT_PaymentScheduleItem/ \"Update a payment schedule item\"); [Preview the result of payment schedule update](https://www.zuora.com/developer/api-references/api/operation/PUT_PaymentScheduleUpdatePreview/ \"Preview the result of payment schedule update\"); [Retrieve a payment schedule](https://www.zuora.com/developer/api-references/api/operation/GET_PaymentSchedule/ \"Retrieve a payment schedule\"); [Retrieve a payment schedule item](https://www.zuora.com/developer/api-references/api/operation/GET_PaymentScheduleItem/ \"Retrieve a payment schedule item\"); [List payment schedules by customer account](https://www.zuora.com/developer/api-references/api/operation/GET_PaymentSchedules/ \"List payment schedules by customer account\"); [Cancel a payment schedule](https://www.zuora.com/developer/api-references/api/operation/PUT_CancelPaymentSchedule/ \"Cancel a payment schedule\"); [Cancel a payment schedule item](https://www.zuora.com/developer/api-references/api/operation/PUT_CancelPaymentScheduleItem/ \"Cancel a payment schedule item\"); [Skip a payment schedule item](https://www.zuora.com/developer/api-references/api/operation/PUT_SkipPaymentScheduleItem/ \"Skip a payment schedule item\"); [Retry failed payment schedule items](https://www.zuora.com/developer/api-references/api/operation/POST_RetryPaymentScheduleItem/ \"Retry failed payment schedule items\"); [List payments](https://www.zuora.com/developer/api-references/api/operation/GET_RetrieveAllPayments/ \"List payments\") | Array of transactional level rules for processing payments. |    #### Version 207.0 and Later  The response structure of the [Preview Subscription](https://www.zuora.com/developer/api-references/api/operation/POST_PreviewSubscription) and [Update Subscription](https://www.zuora.com/developer/api-references/api/operation/PUT_Subscription \"Update Subscription\") methods are changed. The following invoice related response fields are moved to the invoice container:    * amount   * amountWithoutTax   * taxAmount   * invoiceItems   * targetDate   * chargeMetrics   # API Names for Zuora Objects  For information about the Zuora business object model, see [Zuora Business Object Model](https://www.zuora.com/developer/rest-api/general-concepts/object-model/).  You can use the [Describe](https://www.zuora.com/developer/api-references/api/operation/GET_Describe) operation to list the fields of each Zuora object that is available in your tenant. When you call the operation, you must specify the API name of the Zuora object.  The following table provides the API name of each Zuora object:  | Object                                        | API Name                                   | |-----------------------------------------------|--------------------------------------------| | Account                                       | `Account`                                  | | Accounting Code                               | `AccountingCode`                           | | Accounting Period                             | `AccountingPeriod`                         | | Amendment                                     | `Amendment`                                | | Application Group                             | `ApplicationGroup`                         | | Billing Run                                   | <p>`BillingRun` - API name used  in the [Describe](https://www.zuora.com/developer/api-references/api/operation/GET_Describe) operation, Export ZOQL queries, and Data Query.</p> <p>`BillRun` - API name used in the [Actions](https://www.zuora.com/developer/api-references/api/tag/Actions). See the CRUD oprations of [Bill Run](https://www.zuora.com/developer/api-references/api/tag/Bill-Run) for more information about the `BillRun` object. `BillingRun` and `BillRun` have different fields. |                      | Configuration Templates                       | `ConfigurationTemplates`                  | | Contact                                       | `Contact`                                  | | Contact Snapshot                              | `ContactSnapshot`                          | | Credit Balance Adjustment                     | `CreditBalanceAdjustment`                  | | Credit Memo                                   | `CreditMemo`                               | | Credit Memo Application                       | `CreditMemoApplication`                    | | Credit Memo Application Item                  | `CreditMemoApplicationItem`                | | Credit Memo Item                              | `CreditMemoItem`                           | | Credit Memo Part                              | `CreditMemoPart`                           | | Credit Memo Part Item                         | `CreditMemoPartItem`                       | | Credit Taxation Item                          | `CreditTaxationItem`                       | | Custom Exchange Rate                          | `FXCustomRate`                             | | Debit Memo                                    | `DebitMemo`                                | | Debit Memo Item                               | `DebitMemoItem`                            | | Debit Taxation Item                           | `DebitTaxationItem`                        | | Discount Applied Metrics                      | `DiscountAppliedMetrics`                   | | Entity                                        | `Tenant`                                   | | Fulfillment                                   | `Fulfillment`                              | | Feature                                       | `Feature`                                  | | Gateway Reconciliation Event                  | `PaymentGatewayReconciliationEventLog`     | | Gateway Reconciliation Job                    | `PaymentReconciliationJob`                 | | Gateway Reconciliation Log                    | `PaymentReconciliationLog`                 | | Invoice                                       | `Invoice`                                  | | Invoice Adjustment                            | `InvoiceAdjustment`                        | | Invoice Item                                  | `InvoiceItem`                              | | Invoice Item Adjustment                       | `InvoiceItemAdjustment`                    | | Invoice Payment                               | `InvoicePayment`                           | | Invoice Schedule                              | `InvoiceSchedule`                          | | Journal Entry                                 | `JournalEntry`                             | | Journal Entry Item                            | `JournalEntryItem`                         | | Journal Run                                   | `JournalRun`                               | | Notification History - Callout                | `CalloutHistory`                           | | Notification History - Email                  | `EmailHistory`                             | | Offer                                         | `Offer`                             | | Order                                         | `Order`                                    | | Order Action                                  | `OrderAction`                              | | Order ELP                                     | `OrderElp`                                 | | Order Line Items                              | `OrderLineItems`                           |     | Order Item                                    | `OrderItem`                                | | Order MRR                                     | `OrderMrr`                                 | | Order Quantity                                | `OrderQuantity`                            | | Order TCB                                     | `OrderTcb`                                 | | Order TCV                                     | `OrderTcv`                                 | | Payment                                       | `Payment`                                  | | Payment Application                           | `PaymentApplication`                       | | Payment Application Item                      | `PaymentApplicationItem`                   | | Payment Method                                | `PaymentMethod`                            | | Payment Method Snapshot                       | `PaymentMethodSnapshot`                    | | Payment Method Transaction Log                | `PaymentMethodTransactionLog`              | | Payment Method Update                        | `UpdaterDetail`                            | | Payment Part                                  | `PaymentPart`                              | | Payment Part Item                             | `PaymentPartItem`                          | | Payment Run                                   | `PaymentRun`                               | | Payment Transaction Log                       | `PaymentTransactionLog`                    | | Price Book Item                               | `PriceBookItem`                            | | Processed Usage                               | `ProcessedUsage`                           | | Product                                       | `Product`                                  | | Product Feature                               | `ProductFeature`                           | | Product Rate Plan                             | `ProductRatePlan`                          | | Product Rate Plan Charge                      | `ProductRatePlanCharge`                    | | Product Rate Plan Charge Tier                 | `ProductRatePlanChargeTier`                | | Rate Plan                                     | `RatePlan`                                 | | Rate Plan Charge                              | `RatePlanCharge`                           | | Rate Plan Charge Tier                         | `RatePlanChargeTier`                       | | Refund                                        | `Refund`                                   | | Refund Application                            | `RefundApplication`                        | | Refund Application Item                       | `RefundApplicationItem`                    | | Refund Invoice Payment                        | `RefundInvoicePayment`                     | | Refund Part                                   | `RefundPart`                               | | Refund Part Item                              | `RefundPartItem`                           | | Refund Transaction Log                        | `RefundTransactionLog`                     | | Revenue Charge Summary                        | `RevenueChargeSummary`                     | | Revenue Charge Summary Item                   | `RevenueChargeSummaryItem`                 | | Revenue Event                                 | `RevenueEvent`                             | | Revenue Event Credit Memo Item                | `RevenueEventCreditMemoItem`               | | Revenue Event Debit Memo Item                 | `RevenueEventDebitMemoItem`                | | Revenue Event Invoice Item                    | `RevenueEventInvoiceItem`                  | | Revenue Event Invoice Item Adjustment         | `RevenueEventInvoiceItemAdjustment`        | | Revenue Event Item                            | `RevenueEventItem`                         | | Revenue Event Item Credit Memo Item           | `RevenueEventItemCreditMemoItem`           | | Revenue Event Item Debit Memo Item            | `RevenueEventItemDebitMemoItem`            | | Revenue Event Item Invoice Item               | `RevenueEventItemInvoiceItem`              | | Revenue Event Item Invoice Item Adjustment    | `RevenueEventItemInvoiceItemAdjustment`    | | Revenue Event Type                            | `RevenueEventType`                         | | Revenue Schedule                              | `RevenueSchedule`                          | | Revenue Schedule Credit Memo Item             | `RevenueScheduleCreditMemoItem`            | | Revenue Schedule Debit Memo Item              | `RevenueScheduleDebitMemoItem`             | | Revenue Schedule Invoice Item                 | `RevenueScheduleInvoiceItem`               | | Revenue Schedule Invoice Item Adjustment      | `RevenueScheduleInvoiceItemAdjustment`     | | Revenue Schedule Item                         | `RevenueScheduleItem`                      | | Revenue Schedule Item Credit Memo Item        | `RevenueScheduleItemCreditMemoItem`        | | Revenue Schedule Item Debit Memo Item         | `RevenueScheduleItemDebitMemoItem`         | | Revenue Schedule Item Invoice Item            | `RevenueScheduleItemInvoiceItem`           | | Revenue Schedule Item Invoice Item Adjustment | `RevenueScheduleItemInvoiceItemAdjustment` | | Subscription                                  | `Subscription`                             | | Subscription Product Feature                  | `SubscriptionProductFeature`               | | Taxable Item Snapshot                         | `TaxableItemSnapshot`                      | | Taxation Item                                 | `TaxationItem`                             | | Updater Batch                                 | `UpdaterBatch`                             | | Usage                                         | `Usage`                                    |   # noqa: E501

    OpenAPI spec version: 2023-07-24
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

# import apis into sdk package
from swagger_client.api.api_health_api import APIHealthApi
from swagger_client.api.accounting_codes_api import AccountingCodesApi
from swagger_client.api.accounting_periods_api import AccountingPeriodsApi
from swagger_client.api.accounts_api import AccountsApi
from swagger_client.api.actions_api import ActionsApi
from swagger_client.api.adjustments_api import AdjustmentsApi
from swagger_client.api.aggregate_queries_api import AggregateQueriesApi
from swagger_client.api.attachments_api import AttachmentsApi
from swagger_client.api.bill_run_api import BillRunApi
from swagger_client.api.bill_run_health_api import BillRunHealthApi
from swagger_client.api.billing_documents_api import BillingDocumentsApi
from swagger_client.api.billing_preview_run_api import BillingPreviewRunApi
from swagger_client.api.catalog_api import CatalogApi
from swagger_client.api.catalog_groups_api import CatalogGroupsApi
from swagger_client.api.configuration_templates_api import ConfigurationTemplatesApi
from swagger_client.api.contact_snapshots_api import ContactSnapshotsApi
from swagger_client.api.contacts_api import ContactsApi
from swagger_client.api.credit_memos_api import CreditMemosApi
from swagger_client.api.custom_event_triggers_api import CustomEventTriggersApi
from swagger_client.api.custom_exchange_rates_api import CustomExchangeRatesApi
from swagger_client.api.custom_object_definitions_api import CustomObjectDefinitionsApi
from swagger_client.api.custom_object_jobs_api import CustomObjectJobsApi
from swagger_client.api.custom_object_records_api import CustomObjectRecordsApi
from swagger_client.api.custom_payment_method_types_api import CustomPaymentMethodTypesApi
from swagger_client.api.custom_scheduled_events_api import CustomScheduledEventsApi
from swagger_client.api.data_queries_api import DataQueriesApi
from swagger_client.api.debit_memos_api import DebitMemosApi
from swagger_client.api.describe_api import DescribeApi
from swagger_client.api.electronic_payments_health_api import ElectronicPaymentsHealthApi
from swagger_client.api.files_api import FilesApi
from swagger_client.api.fulfillments_api import FulfillmentsApi
from swagger_client.api.hosted_pages_api import HostedPagesApi
from swagger_client.api.imports_api import ImportsApi
from swagger_client.api.invoice_schedules_api import InvoiceSchedulesApi
from swagger_client.api.invoices_api import InvoicesApi
from swagger_client.api.journal_runs_api import JournalRunsApi
from swagger_client.api.mass_updater_api import MassUpdaterApi
from swagger_client.api.notifications_api import NotificationsApi
from swagger_client.api.o_auth_api import OAuthApi
from swagger_client.api.offers_api import OffersApi
from swagger_client.api.operations_api import OperationsApi
from swagger_client.api.order_actions_api import OrderActionsApi
from swagger_client.api.order_line_items_api import OrderLineItemsApi
from swagger_client.api.orders_api import OrdersApi
from swagger_client.api.payment_authorization_api import PaymentAuthorizationApi
from swagger_client.api.payment_gateway_reconciliation_api import PaymentGatewayReconciliationApi
from swagger_client.api.payment_gateways_api import PaymentGatewaysApi
from swagger_client.api.payment_method_snapshots_api import PaymentMethodSnapshotsApi
from swagger_client.api.payment_method_transaction_logs_api import PaymentMethodTransactionLogsApi
from swagger_client.api.payment_method_updater_api import PaymentMethodUpdaterApi
from swagger_client.api.payment_methods_api import PaymentMethodsApi
from swagger_client.api.payment_runs_api import PaymentRunsApi
from swagger_client.api.payment_schedules_api import PaymentSchedulesApi
from swagger_client.api.payment_transaction_logs_api import PaymentTransactionLogsApi
from swagger_client.api.payments_api import PaymentsApi
from swagger_client.api.price_book_items_api import PriceBookItemsApi
from swagger_client.api.product_rate_plan_charge_tiers_api import ProductRatePlanChargeTiersApi
from swagger_client.api.product_rate_plan_charges_api import ProductRatePlanChargesApi
from swagger_client.api.product_rate_plans_api import ProductRatePlansApi
from swagger_client.api.products_api import ProductsApi
from swagger_client.api.rsa_signatures_api import RSASignaturesApi
from swagger_client.api.ramps_api import RampsApi
from swagger_client.api.rate_plans_api import RatePlansApi
from swagger_client.api.refunds_api import RefundsApi
from swagger_client.api.sequence_sets_api import SequenceSetsApi
from swagger_client.api.settings_api import SettingsApi
from swagger_client.api.sign_up_api import SignUpApi
from swagger_client.api.subscriptions_api import SubscriptionsApi
from swagger_client.api.summary_journal_entries_api import SummaryJournalEntriesApi
from swagger_client.api.taxation_items_api import TaxationItemsApi
from swagger_client.api.usage_api import UsageApi
from swagger_client.api.workflows_api import WorkflowsApi
from swagger_client.api.zuora_revenue_integration_api import ZuoraRevenueIntegrationApi

# import ApiClient
from swagger_client.api_client import ApiClient
from swagger_client.configuration import Configuration
# import models into sdk package
from swagger_client.models.account import Account
from swagger_client.models.account_credit_card_holder import AccountCreditCardHolder
from swagger_client.models.account_data import AccountData
from swagger_client.models.account_object_custom_fields import AccountObjectCustomFields
from swagger_client.models.account_object_ns_fields import AccountObjectNSFields
from swagger_client.models.accounting_code_object_custom_fields import AccountingCodeObjectCustomFields
from swagger_client.models.accounting_period_object_custom_fields import AccountingPeriodObjectCustomFields
from swagger_client.models.actions_error_response import ActionsErrorResponse
from swagger_client.models.api_volume_summary_record import ApiVolumeSummaryRecord
from swagger_client.models.apply_credit_memo_type import ApplyCreditMemoType
from swagger_client.models.apply_payment_type import ApplyPaymentType
from swagger_client.models.bad_request_response import BadRequestResponse
from swagger_client.models.bad_request_response_errors import BadRequestResponseErrors
from swagger_client.models.batch_debit_memo_type import BatchDebitMemoType
from swagger_client.models.batch_invoice_type import BatchInvoiceType
from swagger_client.models.batch_queries import BatchQueries
from swagger_client.models.batch_query import BatchQuery
from swagger_client.models.batches_queries import BatchesQueries
from swagger_client.models.batches_queries_by_id import BatchesQueriesById
from swagger_client.models.bill_run_filter_request_type import BillRunFilterRequestType
from swagger_client.models.bill_run_filter_response_type import BillRunFilterResponseType
from swagger_client.models.bill_run_filters import BillRunFilters
from swagger_client.models.bill_run_schedule_request_type import BillRunScheduleRequestType
from swagger_client.models.bill_run_schedule_response_type import BillRunScheduleResponseType
from swagger_client.models.bill_to_contact import BillToContact
from swagger_client.models.bill_to_contact_post_order import BillToContactPostOrder
from swagger_client.models.billing_doc_volume_summary_record import BillingDocVolumeSummaryRecord
from swagger_client.models.billing_document_query_response_element_type import BillingDocumentQueryResponseElementType
from swagger_client.models.billing_options import BillingOptions
from swagger_client.models.billing_preview_result import BillingPreviewResult
from swagger_client.models.billing_update import BillingUpdate
from swagger_client.models.body import Body
from swagger_client.models.body_in_setting_value_reponse import BodyInSettingValueReponse
from swagger_client.models.body_in_setting_value_request import BodyInSettingValueRequest
from swagger_client.models.bulk_credit_memos_response_type import BulkCreditMemosResponseType
from swagger_client.models.bulk_debit_memos_response_type import BulkDebitMemosResponseType
from swagger_client.models.callout_auth import CalloutAuth
from swagger_client.models.callout_merge_fields import CalloutMergeFields
from swagger_client.models.cancel_bill_run_response_type import CancelBillRunResponseType
from swagger_client.models.cancel_subscription import CancelSubscription
from swagger_client.models.catalog_group_response import CatalogGroupResponse
from swagger_client.models.change_plan import ChangePlan
from swagger_client.models.change_plan_rate_plan_override import ChangePlanRatePlanOverride
from swagger_client.models.charge_model_configuration_type import ChargeModelConfigurationType
from swagger_client.models.charge_model_data_override import ChargeModelDataOverride
from swagger_client.models.charge_model_data_override_charge_model_configuration import ChargeModelDataOverrideChargeModelConfiguration
from swagger_client.models.charge_override import ChargeOverride
from swagger_client.models.charge_override_billing import ChargeOverrideBilling
from swagger_client.models.charge_override_pricing import ChargeOverridePricing
from swagger_client.models.charge_preview_metrics import ChargePreviewMetrics
from swagger_client.models.charge_preview_metrics_cmrr import ChargePreviewMetricsCmrr
from swagger_client.models.charge_preview_metrics_tax import ChargePreviewMetricsTax
from swagger_client.models.charge_preview_metrics_tcb import ChargePreviewMetricsTcb
from swagger_client.models.charge_preview_metrics_tcv import ChargePreviewMetricsTcv
from swagger_client.models.charge_tier import ChargeTier
from swagger_client.models.charge_update import ChargeUpdate
from swagger_client.models.charge_update_pricing import ChargeUpdatePricing
from swagger_client.models.children_setting_value_request import ChildrenSettingValueRequest
from swagger_client.models.common_error_response import CommonErrorResponse
from swagger_client.models.common_response_type import CommonResponseType
from swagger_client.models.common_response_type_reasons import CommonResponseTypeReasons
from swagger_client.models.compare_schema_info_response import CompareSchemaInfoResponse
from swagger_client.models.compare_schema_key_value import CompareSchemaKeyValue
from swagger_client.models.config_template_error_response import ConfigTemplateErrorResponse
from swagger_client.models.config_template_error_response_reasons import ConfigTemplateErrorResponseReasons
from swagger_client.models.configuration_template_content import ConfigurationTemplateContent
from swagger_client.models.contact_info import ContactInfo
from swagger_client.models.contact_object_custom_fields import ContactObjectCustomFields
from swagger_client.models.contact_response import ContactResponse
from swagger_client.models.contact_snapshot_object_custom_fields import ContactSnapshotObjectCustomFields
from swagger_client.models.create_change_plan import CreateChangePlan
from swagger_client.models.create_offer_rate_plan_override import CreateOfferRatePlanOverride
from swagger_client.models.create_or_update_email_templates_response import CreateOrUpdateEmailTemplatesResponse
from swagger_client.models.create_order_change_plan_rate_plan_override import CreateOrderChangePlanRatePlanOverride
from swagger_client.models.create_order_charge_override import CreateOrderChargeOverride
from swagger_client.models.create_order_charge_override_billing import CreateOrderChargeOverrideBilling
from swagger_client.models.create_order_charge_override_pricing import CreateOrderChargeOverridePricing
from swagger_client.models.create_order_charge_update import CreateOrderChargeUpdate
from swagger_client.models.create_order_create_subscription import CreateOrderCreateSubscription
from swagger_client.models.create_order_create_subscription_new_subscription_owner_account import CreateOrderCreateSubscriptionNewSubscriptionOwnerAccount
from swagger_client.models.create_order_create_subscription_terms import CreateOrderCreateSubscriptionTerms
from swagger_client.models.create_order_create_subscription_terms_initial_term import CreateOrderCreateSubscriptionTermsInitialTerm
from swagger_client.models.create_order_offer_update import CreateOrderOfferUpdate
from swagger_client.models.create_order_order_action import CreateOrderOrderAction
from swagger_client.models.create_order_order_action_add_product import CreateOrderOrderActionAddProduct
from swagger_client.models.create_order_order_action_update_product import CreateOrderOrderActionUpdateProduct
from swagger_client.models.create_order_order_line_item import CreateOrderOrderLineItem
from swagger_client.models.create_order_pricing_update import CreateOrderPricingUpdate
from swagger_client.models.create_order_pricing_update_charge_model_data import CreateOrderPricingUpdateChargeModelData
from swagger_client.models.create_order_pricing_update_discount import CreateOrderPricingUpdateDiscount
from swagger_client.models.create_order_pricing_update_recurring_delivery_based import CreateOrderPricingUpdateRecurringDeliveryBased
from swagger_client.models.create_order_pricing_update_recurring_flat_fee import CreateOrderPricingUpdateRecurringFlatFee
from swagger_client.models.create_order_pricing_update_recurring_per_unit import CreateOrderPricingUpdateRecurringPerUnit
from swagger_client.models.create_order_pricing_update_recurring_tiered import CreateOrderPricingUpdateRecurringTiered
from swagger_client.models.create_order_pricing_update_recurring_volume import CreateOrderPricingUpdateRecurringVolume
from swagger_client.models.create_order_pricing_update_usage_flat_fee import CreateOrderPricingUpdateUsageFlatFee
from swagger_client.models.create_order_pricing_update_usage_overage import CreateOrderPricingUpdateUsageOverage
from swagger_client.models.create_order_pricing_update_usage_per_unit import CreateOrderPricingUpdateUsagePerUnit
from swagger_client.models.create_order_pricing_update_usage_tiered import CreateOrderPricingUpdateUsageTiered
from swagger_client.models.create_order_pricing_update_usage_tiered_with_overage import CreateOrderPricingUpdateUsageTieredWithOverage
from swagger_client.models.create_order_pricing_update_usage_volume import CreateOrderPricingUpdateUsageVolume
from swagger_client.models.create_order_product_override import CreateOrderProductOverride
from swagger_client.models.create_order_rate_plan_feature_override import CreateOrderRatePlanFeatureOverride
from swagger_client.models.create_order_rate_plan_override import CreateOrderRatePlanOverride
from swagger_client.models.create_order_rate_plan_update import CreateOrderRatePlanUpdate
from swagger_client.models.create_order_resume import CreateOrderResume
from swagger_client.models.create_order_suspend import CreateOrderSuspend
from swagger_client.models.create_order_terms_and_conditions import CreateOrderTermsAndConditions
from swagger_client.models.create_order_trigger_params import CreateOrderTriggerParams
from swagger_client.models.create_order_update_product_trigger_params import CreateOrderUpdateProductTriggerParams
from swagger_client.models.create_pm_pay_pal_ec_pay_pal_native_ec_pay_pal_cp import CreatePMPayPalECPayPalNativeECPayPalCP
from swagger_client.models.create_payment_method_ach import CreatePaymentMethodACH
from swagger_client.models.create_payment_method_apple_pay_adyen import CreatePaymentMethodApplePayAdyen
from swagger_client.models.create_payment_method_bank_transfer import CreatePaymentMethodBankTransfer
from swagger_client.models.create_payment_method_bank_transfer_account_holder_info import CreatePaymentMethodBankTransferAccountHolderInfo
from swagger_client.models.create_payment_method_cc_reference_transaction import CreatePaymentMethodCCReferenceTransaction
from swagger_client.models.create_payment_method_cardholder_info import CreatePaymentMethodCardholderInfo
from swagger_client.models.create_payment_method_common import CreatePaymentMethodCommon
from swagger_client.models.create_payment_method_credit_card import CreatePaymentMethodCreditCard
from swagger_client.models.create_payment_method_google_pay_adyen_chase import CreatePaymentMethodGooglePayAdyenChase
from swagger_client.models.create_payment_method_pay_pal_adaptive import CreatePaymentMethodPayPalAdaptive
from swagger_client.models.create_payment_type import CreatePaymentType
from swagger_client.models.create_stored_credential_profile_request import CreateStoredCredentialProfileRequest
from swagger_client.models.create_subscribe_to_product import CreateSubscribeToProduct
from swagger_client.models.create_subscription import CreateSubscription
from swagger_client.models.create_subscription_new_subscription_owner_account import CreateSubscriptionNewSubscriptionOwnerAccount
from swagger_client.models.create_subscription_terms import CreateSubscriptionTerms
from swagger_client.models.create_template_request_content import CreateTemplateRequestContent
from swagger_client.models.credit_card import CreditCard
from swagger_client.models.credit_memo_apply_debit_memo_item_request_type import CreditMemoApplyDebitMemoItemRequestType
from swagger_client.models.credit_memo_apply_debit_memo_request_type import CreditMemoApplyDebitMemoRequestType
from swagger_client.models.credit_memo_apply_invoice_item_request_type import CreditMemoApplyInvoiceItemRequestType
from swagger_client.models.credit_memo_apply_invoice_request_type import CreditMemoApplyInvoiceRequestType
from swagger_client.models.credit_memo_entity_prefix import CreditMemoEntityPrefix
from swagger_client.models.credit_memo_from_charge_custom_rates_type import CreditMemoFromChargeCustomRatesType
from swagger_client.models.credit_memo_from_charge_detail_type import CreditMemoFromChargeDetailType
from swagger_client.models.credit_memo_from_charge_type import CreditMemoFromChargeType
from swagger_client.models.credit_memo_from_invoice_type import CreditMemoFromInvoiceType
from swagger_client.models.credit_memo_item_from_invoice_item_type import CreditMemoItemFromInvoiceItemType
from swagger_client.models.credit_memo_item_from_write_off_invoice import CreditMemoItemFromWriteOffInvoice
from swagger_client.models.credit_memo_item_object_custom_fields import CreditMemoItemObjectCustomFields
from swagger_client.models.credit_memo_object_custom_fields import CreditMemoObjectCustomFields
from swagger_client.models.credit_memo_object_ns_fields import CreditMemoObjectNSFields
from swagger_client.models.credit_memo_response_type import CreditMemoResponseType
from swagger_client.models.credit_memo_tax_item_from_invoice_tax_item_type import CreditMemoTaxItemFromInvoiceTaxItemType
from swagger_client.models.credit_memo_tax_item_from_invoice_tax_item_type_finance_information import CreditMemoTaxItemFromInvoiceTaxItemTypeFinanceInformation
from swagger_client.models.credit_memo_unapply_debit_memo_item_request_type import CreditMemoUnapplyDebitMemoItemRequestType
from swagger_client.models.credit_memo_unapply_debit_memo_request_type import CreditMemoUnapplyDebitMemoRequestType
from swagger_client.models.credit_memo_unapply_invoice_item_request_type import CreditMemoUnapplyInvoiceItemRequestType
from swagger_client.models.credit_memo_unapply_invoice_request_type import CreditMemoUnapplyInvoiceRequestType
from swagger_client.models.credit_memos_from_charges import CreditMemosFromCharges
from swagger_client.models.credit_memos_from_invoices import CreditMemosFromInvoices
from swagger_client.models.credit_taxation_item_object_custom_fields import CreditTaxationItemObjectCustomFields
from swagger_client.models.custom_account_payment_method import CustomAccountPaymentMethod
from swagger_client.models.custom_fields import CustomFields
from swagger_client.models.custom_object_all_fields_definition import CustomObjectAllFieldsDefinition
from swagger_client.models.custom_object_bulk_delete_filter import CustomObjectBulkDeleteFilter
from swagger_client.models.custom_object_bulk_delete_filter_condition import CustomObjectBulkDeleteFilterCondition
from swagger_client.models.custom_object_bulk_job_error_response import CustomObjectBulkJobErrorResponse
from swagger_client.models.custom_object_bulk_job_error_response_collection import CustomObjectBulkJobErrorResponseCollection
from swagger_client.models.custom_object_bulk_job_request import CustomObjectBulkJobRequest
from swagger_client.models.custom_object_bulk_job_response import CustomObjectBulkJobResponse
from swagger_client.models.custom_object_bulk_job_response_collection import CustomObjectBulkJobResponseCollection
from swagger_client.models.custom_object_bulk_job_response_error import CustomObjectBulkJobResponseError
from swagger_client.models.custom_object_custom_field_definition import CustomObjectCustomFieldDefinition
from swagger_client.models.custom_object_custom_field_definition_update import CustomObjectCustomFieldDefinitionUpdate
from swagger_client.models.custom_object_custom_fields_definition import CustomObjectCustomFieldsDefinition
from swagger_client.models.custom_object_definition import CustomObjectDefinition
from swagger_client.models.custom_object_definition_schema import CustomObjectDefinitionSchema
from swagger_client.models.custom_object_definition_update_action_request import CustomObjectDefinitionUpdateActionRequest
from swagger_client.models.custom_object_definition_update_action_response import CustomObjectDefinitionUpdateActionResponse
from swagger_client.models.custom_object_definitions import CustomObjectDefinitions
from swagger_client.models.custom_object_record_batch_action import CustomObjectRecordBatchAction
from swagger_client.models.custom_object_record_batch_request import CustomObjectRecordBatchRequest
from swagger_client.models.custom_object_record_batch_update_mapping import CustomObjectRecordBatchUpdateMapping
from swagger_client.models.custom_object_record_with_all_fields import CustomObjectRecordWithAllFields
from swagger_client.models.custom_object_record_with_only_custom_fields import CustomObjectRecordWithOnlyCustomFields
from swagger_client.models.custom_object_records_batch_update_partial_success_response import CustomObjectRecordsBatchUpdatePartialSuccessResponse
from swagger_client.models.custom_object_records_error_response import CustomObjectRecordsErrorResponse
from swagger_client.models.custom_object_records_throttled_response import CustomObjectRecordsThrottledResponse
from swagger_client.models.custom_object_records_with_error import CustomObjectRecordsWithError
from swagger_client.models.data_access_control_field import DataAccessControlField
from swagger_client.models.data_query_error_response import DataQueryErrorResponse
from swagger_client.models.data_query_job import DataQueryJob
from swagger_client.models.data_query_job_cancelled import DataQueryJobCancelled
from swagger_client.models.data_query_job_common import DataQueryJobCommon
from swagger_client.models.debit_memo_collect_request import DebitMemoCollectRequest
from swagger_client.models.debit_memo_collect_request_payment import DebitMemoCollectRequestPayment
from swagger_client.models.debit_memo_collect_response import DebitMemoCollectResponse
from swagger_client.models.debit_memo_collect_response_applied_credit_memos import DebitMemoCollectResponseAppliedCreditMemos
from swagger_client.models.debit_memo_collect_response_applied_payments import DebitMemoCollectResponseAppliedPayments
from swagger_client.models.debit_memo_entity_prefix import DebitMemoEntityPrefix
from swagger_client.models.debit_memo_from_charge_custom_rates_type import DebitMemoFromChargeCustomRatesType
from swagger_client.models.debit_memo_from_charge_detail_type import DebitMemoFromChargeDetailType
from swagger_client.models.debit_memo_from_charge_type import DebitMemoFromChargeType
from swagger_client.models.debit_memo_from_invoice_type import DebitMemoFromInvoiceType
from swagger_client.models.debit_memo_item_from_invoice_item_type import DebitMemoItemFromInvoiceItemType
from swagger_client.models.debit_memo_item_object_custom_fields import DebitMemoItemObjectCustomFields
from swagger_client.models.debit_memo_object_custom_fields import DebitMemoObjectCustomFields
from swagger_client.models.debit_memo_object_custom_fields_cm_write_off import DebitMemoObjectCustomFieldsCMWriteOff
from swagger_client.models.debit_memo_object_ns_fields import DebitMemoObjectNSFields
from swagger_client.models.debit_memo_tax_item_from_invoice_tax_item_type import DebitMemoTaxItemFromInvoiceTaxItemType
from swagger_client.models.debit_memo_tax_item_from_invoice_tax_item_type_finance_information import DebitMemoTaxItemFromInvoiceTaxItemTypeFinanceInformation
from swagger_client.models.debit_memos_from_charges import DebitMemosFromCharges
from swagger_client.models.debit_memos_from_invoices import DebitMemosFromInvoices
from swagger_client.models.debit_taxation_item_object_custom_fields import DebitTaxationItemObjectCustomFields
from swagger_client.models.delete_account_response_type import DeleteAccountResponseType
from swagger_client.models.delete_account_response_type_reasons import DeleteAccountResponseTypeReasons
from swagger_client.models.delete_batch_query_job_response import DeleteBatchQueryJobResponse
from swagger_client.models.delete_data_query_job_response import DeleteDataQueryJobResponse
from swagger_client.models.delete_invoice_response_type import DeleteInvoiceResponseType
from swagger_client.models.delete_result import DeleteResult
from swagger_client.models.delete_workflow_error import DeleteWorkflowError
from swagger_client.models.delete_workflow_success import DeleteWorkflowSuccess
from swagger_client.models.deleted_record import DeletedRecord
from swagger_client.models.deleted_record1 import DeletedRecord1
from swagger_client.models.delivery_schedule_params import DeliveryScheduleParams
from swagger_client.models.detailed_workflow import DetailedWorkflow
from swagger_client.models.discount_item_object_custom_fields import DiscountItemObjectCustomFields
from swagger_client.models.discount_item_object_ns_fields import DiscountItemObjectNSFields
from swagger_client.models.discount_pricing_override import DiscountPricingOverride
from swagger_client.models.discount_pricing_update import DiscountPricingUpdate
from swagger_client.models.end_conditions import EndConditions
from swagger_client.models.error401 import Error401
from swagger_client.models.error_response import ErrorResponse
from swagger_client.models.error_response401_record import ErrorResponse401Record
from swagger_client.models.error_response_reasons import ErrorResponseReasons
from swagger_client.models.event_trigger import EventTrigger
from swagger_client.models.event_type import EventType
from swagger_client.models.execute_invoice_schedule_bill_run_response import ExecuteInvoiceScheduleBillRunResponse
from swagger_client.models.export_workflow_version_response import ExportWorkflowVersionResponse
from swagger_client.models.fields_additional_properties import FieldsAdditionalProperties
from swagger_client.models.fields_additional_properties_for_post_definition import FieldsAdditionalPropertiesForPostDefinition
from swagger_client.models.filter_rule_parameter_definition import FilterRuleParameterDefinition
from swagger_client.models.filter_rule_parameter_definitions import FilterRuleParameterDefinitions
from swagger_client.models.filter_rule_parameter_values import FilterRuleParameterValues
from swagger_client.models.fulfillment_common import FulfillmentCommon
from swagger_client.models.fulfillment_custom_fields import FulfillmentCustomFields
from swagger_client.models.fulfillment_get import FulfillmentGet
from swagger_client.models.fulfillment_item_common import FulfillmentItemCommon
from swagger_client.models.fulfillment_item_custom_fields import FulfillmentItemCustomFields
from swagger_client.models.fulfillment_item_get import FulfillmentItemGet
from swagger_client.models.fulfillment_item_post import FulfillmentItemPost
from swagger_client.models.fulfillment_item_post_from_fulfillment_post import FulfillmentItemPostFromFulfillmentPost
from swagger_client.models.fulfillment_item_put import FulfillmentItemPut
from swagger_client.models.fulfillment_post import FulfillmentPost
from swagger_client.models.fulfillment_put import FulfillmentPut
from swagger_client.models.geta_payment_gatway_response import GETAPaymentGatwayResponse
from swagger_client.models.getar_payment_type import GETARPaymentType
from swagger_client.models.getar_payment_type_with_payment_option import GETARPaymentTypeWithPaymentOption
from swagger_client.models.getar_payment_typewith_success import GETARPaymentTypewithSuccess
from swagger_client.models.get_account_pm_account_holder_info import GETAccountPMAccountHolderInfo
from swagger_client.models.get_account_payment_method_type import GETAccountPaymentMethodType
from swagger_client.models.get_account_summary_invoice_type import GETAccountSummaryInvoiceType
from swagger_client.models.get_account_summary_payment_invoice_type import GETAccountSummaryPaymentInvoiceType
from swagger_client.models.get_account_summary_payment_type import GETAccountSummaryPaymentType
from swagger_client.models.get_account_summary_subscription_rate_plan_type import GETAccountSummarySubscriptionRatePlanType
from swagger_client.models.get_account_summary_subscription_type import GETAccountSummarySubscriptionType
from swagger_client.models.get_account_summary_type import GETAccountSummaryType
from swagger_client.models.get_account_summary_type_basic_info import GETAccountSummaryTypeBasicInfo
from swagger_client.models.get_account_summary_type_bill_to_contact import GETAccountSummaryTypeBillToContact
from swagger_client.models.get_account_summary_type_sold_to_contact import GETAccountSummaryTypeSoldToContact
from swagger_client.models.get_account_summary_type_tax_info import GETAccountSummaryTypeTaxInfo
from swagger_client.models.get_account_summary_usage_type import GETAccountSummaryUsageType
from swagger_client.models.get_account_type import GETAccountType
from swagger_client.models.get_account_type_basic_info import GETAccountTypeBasicInfo
from swagger_client.models.get_account_type_bill_to_contact import GETAccountTypeBillToContact
from swagger_client.models.get_account_type_billing_and_payment import GETAccountTypeBillingAndPayment
from swagger_client.models.get_account_type_metrics import GETAccountTypeMetrics
from swagger_client.models.get_account_type_sold_to_contact import GETAccountTypeSoldToContact
from swagger_client.models.get_accounting_code_item_type import GETAccountingCodeItemType
from swagger_client.models.get_accounting_code_item_without_success_type import GETAccountingCodeItemWithoutSuccessType
from swagger_client.models.get_accounting_codes_type import GETAccountingCodesType
from swagger_client.models.get_accounting_period_type import GETAccountingPeriodType
from swagger_client.models.get_accounting_period_without_success_type import GETAccountingPeriodWithoutSuccessType
from swagger_client.models.get_accounting_periods_type import GETAccountingPeriodsType
from swagger_client.models.get_adjustments_by_subscription_number_response_type import GETAdjustmentsBySubscriptionNumberResponseType
from swagger_client.models.get_adjustments_response_type import GETAdjustmentsResponseType
from swagger_client.models.get_all_custom_object_definitions_in_namespace_response import GETAllCustomObjectDefinitionsInNamespaceResponse
from swagger_client.models.get_attachment_response_type import GETAttachmentResponseType
from swagger_client.models.get_attachment_response_without_success_type import GETAttachmentResponseWithoutSuccessType
from swagger_client.models.get_attachments_response_type import GETAttachmentsResponseType
from swagger_client.models.get_billing_document_files_deletion_job_response import GETBillingDocumentFilesDeletionJobResponse
from swagger_client.models.get_billing_documents_response_type import GETBillingDocumentsResponseType
from swagger_client.models.getcm_tax_item_type import GETCMTaxItemType
from swagger_client.models.getcm_tax_item_type_new import GETCMTaxItemTypeNew
from swagger_client.models.get_callout_history_vo_type import GETCalloutHistoryVOType
from swagger_client.models.get_callout_history_vos_type import GETCalloutHistoryVOsType
from swagger_client.models.get_cancel_adjustment_response_type import GETCancelAdjustmentResponseType
from swagger_client.models.get_catalog_group_product_rate_plan_response import GETCatalogGroupProductRatePlanResponse
from swagger_client.models.get_catalog_type import GETCatalogType
from swagger_client.models.get_contact_snapshot_response import GETContactSnapshotResponse
from swagger_client.models.get_credit_memo_collection_type import GETCreditMemoCollectionType
from swagger_client.models.get_credit_memo_item_part_type import GETCreditMemoItemPartType
from swagger_client.models.get_credit_memo_item_part_typewith_success import GETCreditMemoItemPartTypewithSuccess
from swagger_client.models.get_credit_memo_item_parts_collection_type import GETCreditMemoItemPartsCollectionType
from swagger_client.models.get_credit_memo_item_type import GETCreditMemoItemType
from swagger_client.models.get_credit_memo_item_typewith_success import GETCreditMemoItemTypewithSuccess
from swagger_client.models.get_credit_memo_items_list_type import GETCreditMemoItemsListType
from swagger_client.models.get_credit_memo_part_type import GETCreditMemoPartType
from swagger_client.models.get_credit_memo_part_typewith_success import GETCreditMemoPartTypewithSuccess
from swagger_client.models.get_credit_memo_parts_collection_type import GETCreditMemoPartsCollectionType
from swagger_client.models.get_credit_memo_type import GETCreditMemoType
from swagger_client.models.get_credit_memo_typewith_success import GETCreditMemoTypewithSuccess
from swagger_client.models.get_custom_exchange_rates_data_type import GETCustomExchangeRatesDataType
from swagger_client.models.get_custom_exchange_rates_type import GETCustomExchangeRatesType
from swagger_client.models.getdm_tax_item_type import GETDMTaxItemType
from swagger_client.models.getdm_tax_item_type_new import GETDMTaxItemTypeNew
from swagger_client.models.get_debit_memo_collection_type import GETDebitMemoCollectionType
from swagger_client.models.get_debit_memo_item_collection_type import GETDebitMemoItemCollectionType
from swagger_client.models.get_debit_memo_item_type import GETDebitMemoItemType
from swagger_client.models.get_debit_memo_item_typewith_success import GETDebitMemoItemTypewithSuccess
from swagger_client.models.get_debit_memo_type import GETDebitMemoType
from swagger_client.models.get_debit_memo_typewith_success import GETDebitMemoTypewithSuccess
from swagger_client.models.get_delivery_schedule_type import GETDeliveryScheduleType
from swagger_client.models.get_discount_apply_details_type import GETDiscountApplyDetailsType
from swagger_client.models.get_email_history_vo_type import GETEmailHistoryVOType
from swagger_client.models.get_email_history_vos_type import GETEmailHistoryVOsType
from swagger_client.models.get_interval_price_tier_type import GETIntervalPriceTierType
from swagger_client.models.get_interval_price_type import GETIntervalPriceType
from swagger_client.models.get_invoice_files_response import GETInvoiceFilesResponse
from swagger_client.models.get_invoice_items_response import GETInvoiceItemsResponse
from swagger_client.models.get_invoice_tax_item_type import GETInvoiceTaxItemType
from swagger_client.models.get_invoice_taxation_items_response import GETInvoiceTaxationItemsResponse
from swagger_client.models.get_journal_entries_in_journal_run_type import GETJournalEntriesInJournalRunType
from swagger_client.models.get_journal_entry_detail_type import GETJournalEntryDetailType
from swagger_client.models.get_journal_entry_detail_type_without_success import GETJournalEntryDetailTypeWithoutSuccess
from swagger_client.models.get_journal_entry_item_type import GETJournalEntryItemType
from swagger_client.models.get_journal_entry_segment_type import GETJournalEntrySegmentType
from swagger_client.models.get_journal_run_transaction_type import GETJournalRunTransactionType
from swagger_client.models.get_journal_run_type import GETJournalRunType
from swagger_client.models.get_mass_update_type import GETMassUpdateType
from swagger_client.models.get_offer_charge_configuration import GETOfferChargeConfiguration
from swagger_client.models.get_offer_interval_price import GETOfferIntervalPrice
from swagger_client.models.get_offer_price_book_item import GETOfferPriceBookItem
from swagger_client.models.get_offer_product_rate_plan_charge import GETOfferProductRatePlanCharge
from swagger_client.models.get_offer_response import GETOfferResponse
from swagger_client.models.get_offer_tier import GETOfferTier
from swagger_client.models.get_open_payment_method_type_revision_response import GETOpenPaymentMethodTypeRevisionResponse
from swagger_client.models.getpm_account_holder_info import GETPMAccountHolderInfo
from swagger_client.models.get_payment_gatways_response import GETPaymentGatwaysResponse
from swagger_client.models.get_payment_item_part_collection_type import GETPaymentItemPartCollectionType
from swagger_client.models.get_payment_item_part_type import GETPaymentItemPartType
from swagger_client.models.get_payment_item_part_typewith_success import GETPaymentItemPartTypewithSuccess
from swagger_client.models.get_payment_method_response import GETPaymentMethodResponse
from swagger_client.models.get_payment_method_response_ach import GETPaymentMethodResponseACH
from swagger_client.models.get_payment_method_response_ach_for_account import GETPaymentMethodResponseACHForAccount
from swagger_client.models.get_payment_method_response_apple_pay import GETPaymentMethodResponseApplePay
from swagger_client.models.get_payment_method_response_apple_pay_for_account import GETPaymentMethodResponseApplePayForAccount
from swagger_client.models.get_payment_method_response_bank_transfer import GETPaymentMethodResponseBankTransfer
from swagger_client.models.get_payment_method_response_bank_transfer_for_account import GETPaymentMethodResponseBankTransferForAccount
from swagger_client.models.get_payment_method_response_credit_card import GETPaymentMethodResponseCreditCard
from swagger_client.models.get_payment_method_response_credit_card_for_account import GETPaymentMethodResponseCreditCardForAccount
from swagger_client.models.get_payment_method_response_for_account import GETPaymentMethodResponseForAccount
from swagger_client.models.get_payment_method_response_google_pay import GETPaymentMethodResponseGooglePay
from swagger_client.models.get_payment_method_response_google_pay_for_account import GETPaymentMethodResponseGooglePayForAccount
from swagger_client.models.get_payment_method_response_pay_pal import GETPaymentMethodResponsePayPal
from swagger_client.models.get_payment_method_response_pay_pal_for_account import GETPaymentMethodResponsePayPalForAccount
from swagger_client.models.get_payment_method_updater_instances_response import GETPaymentMethodUpdaterInstancesResponse
from swagger_client.models.get_payment_method_updater_instances_response_updaters import GETPaymentMethodUpdaterInstancesResponseUpdaters
from swagger_client.models.get_payment_part_type import GETPaymentPartType
from swagger_client.models.get_payment_part_typewith_success import GETPaymentPartTypewithSuccess
from swagger_client.models.get_payment_parts_collection_type import GETPaymentPartsCollectionType
from swagger_client.models.get_payment_run_collection_type import GETPaymentRunCollectionType
from swagger_client.models.get_payment_run_data_array_response import GETPaymentRunDataArrayResponse
from swagger_client.models.get_payment_run_data_element_response import GETPaymentRunDataElementResponse
from swagger_client.models.get_payment_run_data_transaction_element_response import GETPaymentRunDataTransactionElementResponse
from swagger_client.models.get_payment_run_summary_response import GETPaymentRunSummaryResponse
from swagger_client.models.get_payment_run_summary_total_values import GETPaymentRunSummaryTotalValues
from swagger_client.models.get_payment_run_type import GETPaymentRunType
from swagger_client.models.get_payment_schedule_item_response import GETPaymentScheduleItemResponse
from swagger_client.models.get_payment_schedule_response import GETPaymentScheduleResponse
from swagger_client.models.get_payment_schedule_statistic_response import GETPaymentScheduleStatisticResponse
from swagger_client.models.get_payment_schedule_statistic_response_payment_schedule_items import GETPaymentScheduleStatisticResponsePaymentScheduleItems
from swagger_client.models.get_payment_schedules_response import GETPaymentSchedulesResponse
from swagger_client.models.get_price_book_item_interval_price import GETPriceBookItemIntervalPrice
from swagger_client.models.get_price_book_item_response import GETPriceBookItemResponse
from swagger_client.models.get_price_book_item_tier import GETPriceBookItemTier
from swagger_client.models.get_product_discount_apply_details_type import GETProductDiscountApplyDetailsType
from swagger_client.models.get_product_rate_plan_charge_delivery_schedule import GETProductRatePlanChargeDeliverySchedule
from swagger_client.models.get_product_rate_plan_charge_pricing_tier_type import GETProductRatePlanChargePricingTierType
from swagger_client.models.get_product_rate_plan_charge_pricing_type import GETProductRatePlanChargePricingType
from swagger_client.models.get_product_rate_plan_charge_type import GETProductRatePlanChargeType
from swagger_client.models.get_product_rate_plan_type import GETProductRatePlanType
from swagger_client.models.get_product_rate_plan_with_external_id_multi_response import GETProductRatePlanWithExternalIdMultiResponse
from swagger_client.models.get_product_rate_plan_with_external_id_multi_response_inner import GETProductRatePlanWithExternalIdMultiResponseInner
from swagger_client.models.get_product_rate_plan_with_external_id_response import GETProductRatePlanWithExternalIdResponse
from swagger_client.models.get_product_rate_plans_response import GETProductRatePlansResponse
from swagger_client.models.get_product_type import GETProductType
from swagger_client.models.get_public_email_template_response import GETPublicEmailTemplateResponse
from swagger_client.models.get_public_notification_definition_response import GETPublicNotificationDefinitionResponse
from swagger_client.models.get_public_notification_definition_response_callout import GETPublicNotificationDefinitionResponseCallout
from swagger_client.models.get_public_notification_definition_response_filter_rule import GETPublicNotificationDefinitionResponseFilterRule
from swagger_client.models.get_ramp_by_ramp_number_response_type import GETRampByRampNumberResponseType
from swagger_client.models.get_ramp_metrics_by_order_number_response_type import GETRampMetricsByOrderNumberResponseType
from swagger_client.models.get_ramp_metrics_by_ramp_number_response_type import GETRampMetricsByRampNumberResponseType
from swagger_client.models.get_ramp_metrics_by_subscription_key_response_type import GETRampMetricsBySubscriptionKeyResponseType
from swagger_client.models.get_ramps_by_subscription_key_response_type import GETRampsBySubscriptionKeyResponseType
from swagger_client.models.get_refund_collection_type import GETRefundCollectionType
from swagger_client.models.get_refund_credit_memo_type import GETRefundCreditMemoType
from swagger_client.models.get_refund_item_part_collection_type import GETRefundItemPartCollectionType
from swagger_client.models.get_refund_item_part_type import GETRefundItemPartType
from swagger_client.models.get_refund_item_part_typewith_success import GETRefundItemPartTypewithSuccess
from swagger_client.models.get_refund_part_collection_type import GETRefundPartCollectionType
from swagger_client.models.get_refund_payment_type import GETRefundPaymentType
from swagger_client.models.get_refund_type import GETRefundType
from swagger_client.models.get_refund_typewith_success import GETRefundTypewithSuccess
from swagger_client.models.get_sequence_set_response import GETSequenceSetResponse
from swagger_client.models.get_sequence_sets_response import GETSequenceSetsResponse
from swagger_client.models.get_subscription_offer_type import GETSubscriptionOfferType
from swagger_client.models.get_subscription_product_feature_type import GETSubscriptionProductFeatureType
from swagger_client.models.get_subscription_rate_plan_charges_type import GETSubscriptionRatePlanChargesType
from swagger_client.models.get_subscription_rate_plan_type import GETSubscriptionRatePlanType
from swagger_client.models.get_subscription_status_history_type import GETSubscriptionStatusHistoryType
from swagger_client.models.get_subscription_type import GETSubscriptionType
from swagger_client.models.get_subscription_type_with_success import GETSubscriptionTypeWithSuccess
from swagger_client.models.get_subscription_wrapper import GETSubscriptionWrapper
from swagger_client.models.get_taxation_item_list_type import GETTaxationItemListType
from swagger_client.models.get_taxation_item_type import GETTaxationItemType
from swagger_client.models.get_taxation_item_typewith_success import GETTaxationItemTypewithSuccess
from swagger_client.models.get_taxation_items_of_credit_memo_item_type import GETTaxationItemsOfCreditMemoItemType
from swagger_client.models.get_taxation_items_of_debit_memo_item_type import GETTaxationItemsOfDebitMemoItemType
from swagger_client.models.get_tier_type import GETTierType
from swagger_client.models.get_usage_rate_detail_wrapper import GETUsageRateDetailWrapper
from swagger_client.models.get_usage_rate_detail_wrapper_data import GETUsageRateDetailWrapperData
from swagger_client.models.get_usage_type import GETUsageType
from swagger_client.models.get_usage_wrapper import GETUsageWrapper
from swagger_client.models.generate_billing_document_response_type import GenerateBillingDocumentResponseType
from swagger_client.models.get_aggregate_query_job_response import GetAggregateQueryJobResponse
from swagger_client.models.get_all_orders_response_type import GetAllOrdersResponseType
from swagger_client.models.get_api_volume_summary_response import GetApiVolumeSummaryResponse
from swagger_client.models.get_bill_run_response_type import GetBillRunResponseType
from swagger_client.models.get_billing_doc_volume_summary_response import GetBillingDocVolumeSummaryResponse
from swagger_client.models.get_billing_preview_run_response import GetBillingPreviewRunResponse
from swagger_client.models.get_data_query_job_response import GetDataQueryJobResponse
from swagger_client.models.get_data_query_jobs_response import GetDataQueryJobsResponse
from swagger_client.models.get_debit_memo_application_part_collection_type import GetDebitMemoApplicationPartCollectionType
from swagger_client.models.get_debit_memo_application_part_type import GetDebitMemoApplicationPartType
from swagger_client.models.get_fulfillment_item_response_type import GetFulfillmentItemResponseType
from swagger_client.models.get_fulfillment_response_type import GetFulfillmentResponseType
from swagger_client.models.get_hosted_page_type import GetHostedPageType
from swagger_client.models.get_hosted_pages_type import GetHostedPagesType
from swagger_client.models.get_invoice_application_part_collection_type import GetInvoiceApplicationPartCollectionType
from swagger_client.models.get_invoice_application_part_type import GetInvoiceApplicationPartType
from swagger_client.models.get_offer_rate_plan_override import GetOfferRatePlanOverride
from swagger_client.models.get_offer_rate_plan_update import GetOfferRatePlanUpdate
from swagger_client.models.get_operation_job_response_type import GetOperationJobResponseType
from swagger_client.models.get_order_action_rate_plan_response import GetOrderActionRatePlanResponse
from swagger_client.models.get_order_line_item_response_type import GetOrderLineItemResponseType
from swagger_client.models.get_order_response import GetOrderResponse
from swagger_client.models.get_order_resume import GetOrderResume
from swagger_client.models.get_order_suspend import GetOrderSuspend
from swagger_client.models.get_orders_response import GetOrdersResponse
from swagger_client.models.get_payment_volume_summary_response import GetPaymentVolumeSummaryResponse
from swagger_client.models.get_product_feature_type import GetProductFeatureType
from swagger_client.models.get_scheduled_event_response import GetScheduledEventResponse
from swagger_client.models.get_scheduled_event_response_parameters import GetScheduledEventResponseParameters
from swagger_client.models.get_stored_credential_profiles_response import GetStoredCredentialProfilesResponse
from swagger_client.models.get_stored_credential_profiles_response_profiles import GetStoredCredentialProfilesResponseProfiles
from swagger_client.models.get_versions_response import GetVersionsResponse
from swagger_client.models.get_workflow_response import GetWorkflowResponse
from swagger_client.models.get_workflow_response_tasks import GetWorkflowResponseTasks
from swagger_client.models.get_workflows_response import GetWorkflowsResponse
from swagger_client.models.get_workflows_response_pagination import GetWorkflowsResponsePagination
from swagger_client.models.initial_term import InitialTerm
from swagger_client.models.inline_response200 import InlineResponse200
from swagger_client.models.inline_response2001 import InlineResponse2001
from swagger_client.models.inline_response2002 import InlineResponse2002
from swagger_client.models.inline_response2003 import InlineResponse2003
from swagger_client.models.inline_response2004 import InlineResponse2004
from swagger_client.models.inline_response2005 import InlineResponse2005
from swagger_client.models.inline_response202 import InlineResponse202
from swagger_client.models.inline_response2021 import InlineResponse2021
from swagger_client.models.inline_response400 import InlineResponse400
from swagger_client.models.inline_response406 import InlineResponse406
from swagger_client.models.invoice_entity_prefix import InvoiceEntityPrefix
from swagger_client.models.invoice_file import InvoiceFile
from swagger_client.models.invoice_item import InvoiceItem
from swagger_client.models.invoice_item_object_custom_fields import InvoiceItemObjectCustomFields
from swagger_client.models.invoice_item_object_ns_fields import InvoiceItemObjectNSFields
from swagger_client.models.invoice_item_preview_result import InvoiceItemPreviewResult
from swagger_client.models.invoice_item_preview_result_additional_info import InvoiceItemPreviewResultAdditionalInfo
from swagger_client.models.invoice_item_preview_result_taxation_items import InvoiceItemPreviewResultTaxationItems
from swagger_client.models.invoice_object_custom_fields import InvoiceObjectCustomFields
from swagger_client.models.invoice_object_ns_fields import InvoiceObjectNSFields
from swagger_client.models.invoice_post_response_type import InvoicePostResponseType
from swagger_client.models.invoice_post_type import InvoicePostType
from swagger_client.models.invoice_response_type import InvoiceResponseType
from swagger_client.models.invoice_schedule_custom_fields import InvoiceScheduleCustomFields
from swagger_client.models.invoice_schedule_item_custom_fields import InvoiceScheduleItemCustomFields
from swagger_client.models.invoice_schedule_responses import InvoiceScheduleResponses
from swagger_client.models.invoice_schedule_specific_subscriptions import InvoiceScheduleSpecificSubscriptions
from swagger_client.models.invoice_with_custom_rates_type import InvoiceWithCustomRatesType
from swagger_client.models.invoices_batch_post_response_type import InvoicesBatchPostResponseType
from swagger_client.models.job_result import JobResult
from swagger_client.models.job_result_order_line_items import JobResultOrderLineItems
from swagger_client.models.job_result_ramps import JobResultRamps
from swagger_client.models.job_result_subscriptions import JobResultSubscriptions
from swagger_client.models.journal_entry_item_object_custom_fields import JournalEntryItemObjectCustomFields
from swagger_client.models.journal_entry_object_custom_fields import JournalEntryObjectCustomFields
from swagger_client.models.json_node import JsonNode
from swagger_client.models.last_term import LastTerm
from swagger_client.models.linkage import Linkage
from swagger_client.models.linked_payment_id import LinkedPaymentID
from swagger_client.models.list_all_catalog_groups_response import ListAllCatalogGroupsResponse
from swagger_client.models.list_all_offers_response import ListAllOffersResponse
from swagger_client.models.list_all_price_book_items_response import ListAllPriceBookItemsResponse
from swagger_client.models.list_all_settings_response import ListAllSettingsResponse
from swagger_client.models.list_of_exchange_rates import ListOfExchangeRates
from swagger_client.models.migration_client_response import MigrationClientResponse
from swagger_client.models.migration_component_content import MigrationComponentContent
from swagger_client.models.migration_update_custom_object_definitions_request import MigrationUpdateCustomObjectDefinitionsRequest
from swagger_client.models.migration_update_custom_object_definitions_response import MigrationUpdateCustomObjectDefinitionsResponse
from swagger_client.models.modified_stored_credential_profile_response import ModifiedStoredCredentialProfileResponse
from swagger_client.models.next_run_response_type import NextRunResponseType
from swagger_client.models.notifications_history_deletion_task_response import NotificationsHistoryDeletionTaskResponse
from swagger_client.models.offer_override import OfferOverride
from swagger_client.models.offer_update import OfferUpdate
from swagger_client.models.one_time_flat_fee_pricing_override import OneTimeFlatFeePricingOverride
from swagger_client.models.one_time_per_unit_pricing_override import OneTimePerUnitPricingOverride
from swagger_client.models.one_time_tiered_pricing_override import OneTimeTieredPricingOverride
from swagger_client.models.one_time_volume_pricing_override import OneTimeVolumePricingOverride
from swagger_client.models.open_payment_method_type_request_fields import OpenPaymentMethodTypeRequestFields
from swagger_client.models.open_payment_method_type_response_fields import OpenPaymentMethodTypeResponseFields
from swagger_client.models.options import Options
from swagger_client.models.order import Order
from swagger_client.models.order_action import OrderAction
from swagger_client.models.order_action_add_product import OrderActionAddProduct
from swagger_client.models.order_action_common import OrderActionCommon
from swagger_client.models.order_action_custom_fields import OrderActionCustomFields
from swagger_client.models.order_action_object_custom_fields import OrderActionObjectCustomFields
from swagger_client.models.order_action_put import OrderActionPut
from swagger_client.models.order_action_rate_plan_amendment import OrderActionRatePlanAmendment
from swagger_client.models.order_action_rate_plan_billing_update import OrderActionRatePlanBillingUpdate
from swagger_client.models.order_action_rate_plan_charge_model_data_override import OrderActionRatePlanChargeModelDataOverride
from swagger_client.models.order_action_rate_plan_charge_model_data_override_charge_model_configuration import OrderActionRatePlanChargeModelDataOverrideChargeModelConfiguration
from swagger_client.models.order_action_rate_plan_charge_override import OrderActionRatePlanChargeOverride
from swagger_client.models.order_action_rate_plan_charge_override_pricing import OrderActionRatePlanChargeOverridePricing
from swagger_client.models.order_action_rate_plan_charge_tier import OrderActionRatePlanChargeTier
from swagger_client.models.order_action_rate_plan_charge_update import OrderActionRatePlanChargeUpdate
from swagger_client.models.order_action_rate_plan_charge_update_billing import OrderActionRatePlanChargeUpdateBilling
from swagger_client.models.order_action_rate_plan_discount_pricing_override import OrderActionRatePlanDiscountPricingOverride
from swagger_client.models.order_action_rate_plan_discount_pricing_update import OrderActionRatePlanDiscountPricingUpdate
from swagger_client.models.order_action_rate_plan_end_conditions import OrderActionRatePlanEndConditions
from swagger_client.models.order_action_rate_plan_one_time_flat_fee_pricing_override import OrderActionRatePlanOneTimeFlatFeePricingOverride
from swagger_client.models.order_action_rate_plan_one_time_per_unit_pricing_override import OrderActionRatePlanOneTimePerUnitPricingOverride
from swagger_client.models.order_action_rate_plan_one_time_tiered_pricing_override import OrderActionRatePlanOneTimeTieredPricingOverride
from swagger_client.models.order_action_rate_plan_one_time_volume_pricing_override import OrderActionRatePlanOneTimeVolumePricingOverride
from swagger_client.models.order_action_rate_plan_order import OrderActionRatePlanOrder
from swagger_client.models.order_action_rate_plan_order_action import OrderActionRatePlanOrderAction
from swagger_client.models.order_action_rate_plan_order_action_object_custom_fields import OrderActionRatePlanOrderActionObjectCustomFields
from swagger_client.models.order_action_rate_plan_price_change_params import OrderActionRatePlanPriceChangeParams
from swagger_client.models.order_action_rate_plan_pricing_update import OrderActionRatePlanPricingUpdate
from swagger_client.models.order_action_rate_plan_pricing_update_charge_model_data import OrderActionRatePlanPricingUpdateChargeModelData
from swagger_client.models.order_action_rate_plan_pricing_update_recurring_delivery import OrderActionRatePlanPricingUpdateRecurringDelivery
from swagger_client.models.order_action_rate_plan_rate_plan_charge_object_custom_fields import OrderActionRatePlanRatePlanChargeObjectCustomFields
from swagger_client.models.order_action_rate_plan_rate_plan_object_custom_fields import OrderActionRatePlanRatePlanObjectCustomFields
from swagger_client.models.order_action_rate_plan_rate_plan_override import OrderActionRatePlanRatePlanOverride
from swagger_client.models.order_action_rate_plan_rate_plan_update import OrderActionRatePlanRatePlanUpdate
from swagger_client.models.order_action_rate_plan_recurring_delivery_pricing_override import OrderActionRatePlanRecurringDeliveryPricingOverride
from swagger_client.models.order_action_rate_plan_recurring_delivery_pricing_update import OrderActionRatePlanRecurringDeliveryPricingUpdate
from swagger_client.models.order_action_rate_plan_recurring_flat_fee_pricing_override import OrderActionRatePlanRecurringFlatFeePricingOverride
from swagger_client.models.order_action_rate_plan_recurring_flat_fee_pricing_update import OrderActionRatePlanRecurringFlatFeePricingUpdate
from swagger_client.models.order_action_rate_plan_recurring_per_unit_pricing_override import OrderActionRatePlanRecurringPerUnitPricingOverride
from swagger_client.models.order_action_rate_plan_recurring_per_unit_pricing_update import OrderActionRatePlanRecurringPerUnitPricingUpdate
from swagger_client.models.order_action_rate_plan_recurring_tiered_pricing_override import OrderActionRatePlanRecurringTieredPricingOverride
from swagger_client.models.order_action_rate_plan_recurring_tiered_pricing_update import OrderActionRatePlanRecurringTieredPricingUpdate
from swagger_client.models.order_action_rate_plan_recurring_volume_pricing_override import OrderActionRatePlanRecurringVolumePricingOverride
from swagger_client.models.order_action_rate_plan_recurring_volume_pricing_update import OrderActionRatePlanRecurringVolumePricingUpdate
from swagger_client.models.order_action_rate_plan_remove_product import OrderActionRatePlanRemoveProduct
from swagger_client.models.order_action_rate_plan_trigger_params import OrderActionRatePlanTriggerParams
from swagger_client.models.order_action_rate_plan_usage_flat_fee_pricing_override import OrderActionRatePlanUsageFlatFeePricingOverride
from swagger_client.models.order_action_rate_plan_usage_flat_fee_pricing_update import OrderActionRatePlanUsageFlatFeePricingUpdate
from swagger_client.models.order_action_rate_plan_usage_overage_pricing_override import OrderActionRatePlanUsageOveragePricingOverride
from swagger_client.models.order_action_rate_plan_usage_overage_pricing_update import OrderActionRatePlanUsageOveragePricingUpdate
from swagger_client.models.order_action_rate_plan_usage_per_unit_pricing_override import OrderActionRatePlanUsagePerUnitPricingOverride
from swagger_client.models.order_action_rate_plan_usage_per_unit_pricing_update import OrderActionRatePlanUsagePerUnitPricingUpdate
from swagger_client.models.order_action_rate_plan_usage_tiered_pricing_override import OrderActionRatePlanUsageTieredPricingOverride
from swagger_client.models.order_action_rate_plan_usage_tiered_pricing_update import OrderActionRatePlanUsageTieredPricingUpdate
from swagger_client.models.order_action_rate_plan_usage_tiered_with_overage_pricing_override import OrderActionRatePlanUsageTieredWithOveragePricingOverride
from swagger_client.models.order_action_rate_plan_usage_tiered_with_overage_pricing_update import OrderActionRatePlanUsageTieredWithOveragePricingUpdate
from swagger_client.models.order_action_rate_plan_usage_volume_pricing_override import OrderActionRatePlanUsageVolumePricingOverride
from swagger_client.models.order_action_rate_plan_usage_volume_pricing_update import OrderActionRatePlanUsageVolumePricingUpdate
from swagger_client.models.order_action_update_product import OrderActionUpdateProduct
from swagger_client.models.order_delta_metric import OrderDeltaMetric
from swagger_client.models.order_delta_mrr import OrderDeltaMrr
from swagger_client.models.order_delta_tcb import OrderDeltaTcb
from swagger_client.models.order_delta_tcv import OrderDeltaTcv
from swagger_client.models.order_item import OrderItem
from swagger_client.models.order_line_item import OrderLineItem
from swagger_client.models.order_line_item_common import OrderLineItemCommon
from swagger_client.models.order_line_item_common_post_order import OrderLineItemCommonPostOrder
from swagger_client.models.order_line_item_common_retrieve_order import OrderLineItemCommonRetrieveOrder
from swagger_client.models.order_line_item_common_retrieve_order_line_item import OrderLineItemCommonRetrieveOrderLineItem
from swagger_client.models.order_line_item_custom_fields import OrderLineItemCustomFields
from swagger_client.models.order_line_item_custom_fields_retrieve_order_line_item import OrderLineItemCustomFieldsRetrieveOrderLineItem
from swagger_client.models.order_line_item_retrieve_order import OrderLineItemRetrieveOrder
from swagger_client.models.order_metric import OrderMetric
from swagger_client.models.order_object_custom_fields import OrderObjectCustomFields
from swagger_client.models.order_ramp_interval_metrics import OrderRampIntervalMetrics
from swagger_client.models.order_ramp_metrics import OrderRampMetrics
from swagger_client.models.order_scheduling_options import OrderSchedulingOptions
from swagger_client.models.order_subscriptions import OrderSubscriptions
from swagger_client.models.orders_rate_plan_object_custom_fields import OrdersRatePlanObjectCustomFields
from swagger_client.models.owner_transfer import OwnerTransfer
from swagger_client.models.post_account_pm_mandate_info import POSTAccountPMMandateInfo
from swagger_client.models.post_account_response_type import POSTAccountResponseType
from swagger_client.models.post_account_type import POSTAccountType
from swagger_client.models.post_account_type_bill_to_contact import POSTAccountTypeBillToContact
from swagger_client.models.post_account_type_credit_card import POSTAccountTypeCreditCard
from swagger_client.models.post_account_type_payment_method import POSTAccountTypePaymentMethod
from swagger_client.models.post_account_type_sold_to_contact import POSTAccountTypeSoldToContact
from swagger_client.models.post_account_type_subscription import POSTAccountTypeSubscription
from swagger_client.models.post_accounting_code_response_type import POSTAccountingCodeResponseType
from swagger_client.models.post_accounting_code_type import POSTAccountingCodeType
from swagger_client.models.post_accounting_period_response_type import POSTAccountingPeriodResponseType
from swagger_client.models.post_accounting_period_type import POSTAccountingPeriodType
from swagger_client.models.post_add_items_to_payment_schedule_request import POSTAddItemsToPaymentScheduleRequest
from swagger_client.models.post_adjustment_response_type import POSTAdjustmentResponseType
from swagger_client.models.post_attachment_response_type import POSTAttachmentResponseType
from swagger_client.models.post_authorize_response import POSTAuthorizeResponse
from swagger_client.models.post_authorize_response_payment_gateway_response import POSTAuthorizeResponsePaymentGatewayResponse
from swagger_client.models.post_authorize_response_reasons import POSTAuthorizeResponseReasons
from swagger_client.models.post_billing_document_files_deletion_job_request import POSTBillingDocumentFilesDeletionJobRequest
from swagger_client.models.post_billing_document_files_deletion_job_response import POSTBillingDocumentFilesDeletionJobResponse
from swagger_client.models.post_billing_preview_credit_memo_item import POSTBillingPreviewCreditMemoItem
from swagger_client.models.post_billing_preview_invoice_item import POSTBillingPreviewInvoiceItem
from swagger_client.models.post_bulk_credit_memo_from_invoice_type import POSTBulkCreditMemoFromInvoiceType
from swagger_client.models.post_bulk_credit_memos_request_type import POSTBulkCreditMemosRequestType
from swagger_client.models.post_bulk_debit_memo_from_invoice_type import POSTBulkDebitMemoFromInvoiceType
from swagger_client.models.post_bulk_debit_memos_request_type import POSTBulkDebitMemosRequestType
from swagger_client.models.post_catalog_group_request import POSTCatalogGroupRequest
from swagger_client.models.post_contact_type import POSTContactType
from swagger_client.models.post_create_bill_run_request_type import POSTCreateBillRunRequestType
from swagger_client.models.post_create_billing_adjustment_request_type import POSTCreateBillingAdjustmentRequestType
from swagger_client.models.post_create_billing_adjustment_request_type_exclusion import POSTCreateBillingAdjustmentRequestTypeExclusion
from swagger_client.models.post_create_invoice_schedule_request import POSTCreateInvoiceScheduleRequest
from swagger_client.models.post_create_open_payment_method_type_request import POSTCreateOpenPaymentMethodTypeRequest
from swagger_client.models.post_create_open_payment_method_type_response import POSTCreateOpenPaymentMethodTypeResponse
from swagger_client.models.post_create_or_update_email_template_request import POSTCreateOrUpdateEmailTemplateRequest
from swagger_client.models.post_create_or_update_email_template_request_format import POSTCreateOrUpdateEmailTemplateRequestFormat
from swagger_client.models.post_create_payment_session_request import POSTCreatePaymentSessionRequest
from swagger_client.models.post_create_payment_session_response import POSTCreatePaymentSessionResponse
from swagger_client.models.post_decrypt_response_type import POSTDecryptResponseType
from swagger_client.models.post_decryption_type import POSTDecryptionType
from swagger_client.models.post_delay_authorize_capture import POSTDelayAuthorizeCapture
from swagger_client.models.post_delay_authorize_capture_gateway_options import POSTDelayAuthorizeCaptureGatewayOptions
from swagger_client.models.post_email_billing_docfrom_bill_run_type import POSTEmailBillingDocfromBillRunType
from swagger_client.models.post_execute_invoice_schedule_request import POSTExecuteInvoiceScheduleRequest
from swagger_client.models.post_ineligible_adjustment_response_type import POSTIneligibleAdjustmentResponseType
from swagger_client.models.post_invoice_collect_credit_memos_type import POSTInvoiceCollectCreditMemosType
from swagger_client.models.post_invoice_collect_invoices_type import POSTInvoiceCollectInvoicesType
from swagger_client.models.post_invoice_collect_response_type import POSTInvoiceCollectResponseType
from swagger_client.models.post_invoice_collect_type import POSTInvoiceCollectType
from swagger_client.models.post_invoices_batch_post_type import POSTInvoicesBatchPostType
from swagger_client.models.post_journal_entry_item_type import POSTJournalEntryItemType
from swagger_client.models.post_journal_entry_response_type import POSTJournalEntryResponseType
from swagger_client.models.post_journal_entry_segment_type import POSTJournalEntrySegmentType
from swagger_client.models.post_journal_entry_type import POSTJournalEntryType
from swagger_client.models.post_journal_run_response_type import POSTJournalRunResponseType
from swagger_client.models.post_journal_run_transaction_type import POSTJournalRunTransactionType
from swagger_client.models.post_journal_run_type import POSTJournalRunType
from swagger_client.models.post_mass_update_response_type import POSTMassUpdateResponseType
from swagger_client.models.post_memo_pdf_response import POSTMemoPdfResponse
from swagger_client.models.post_offer_charge_configuration import POSTOfferChargeConfiguration
from swagger_client.models.post_offer_charge_override import POSTOfferChargeOverride
from swagger_client.models.post_offer_interval_price import POSTOfferIntervalPrice
from swagger_client.models.post_offer_price_book_item import POSTOfferPriceBookItem
from swagger_client.models.post_offer_product_rate_plan import POSTOfferProductRatePlan
from swagger_client.models.post_offer_request import POSTOfferRequest
from swagger_client.models.post_offer_response import POSTOfferResponse
from swagger_client.models.post_offer_tier import POSTOfferTier
from swagger_client.models.post_order_async_request_type import POSTOrderAsyncRequestType
from swagger_client.models.post_order_async_request_type_subscriptions import POSTOrderAsyncRequestTypeSubscriptions
from swagger_client.models.post_order_preview_async_request_type import POSTOrderPreviewAsyncRequestType
from swagger_client.models.post_order_preview_async_request_type_subscriptions import POSTOrderPreviewAsyncRequestTypeSubscriptions
from swagger_client.models.post_order_preview_request_type import POSTOrderPreviewRequestType
from swagger_client.models.post_order_request_type import POSTOrderRequestType
from swagger_client.models.post_order_request_type_scheduling_options import POSTOrderRequestTypeSchedulingOptions
from swagger_client.models.postpm_mandate_info import POSTPMMandateInfo
from swagger_client.models.post_payment_method_decryption import POSTPaymentMethodDecryption
from swagger_client.models.post_payment_method_request import POSTPaymentMethodRequest
from swagger_client.models.post_payment_method_response import POSTPaymentMethodResponse
from swagger_client.models.post_payment_method_response_decryption import POSTPaymentMethodResponseDecryption
from swagger_client.models.post_payment_method_response_reasons import POSTPaymentMethodResponseReasons
from swagger_client.models.post_payment_method_updater_batch_request import POSTPaymentMethodUpdaterBatchRequest
from swagger_client.models.post_payment_method_updater_response import POSTPaymentMethodUpdaterResponse
from swagger_client.models.post_payment_method_updater_response_reasons import POSTPaymentMethodUpdaterResponseReasons
from swagger_client.models.post_payment_run_data_element_request import POSTPaymentRunDataElementRequest
from swagger_client.models.post_payment_run_request import POSTPaymentRunRequest
from swagger_client.models.post_payment_schedule_request import POSTPaymentScheduleRequest
from swagger_client.models.post_payment_schedule_response import POSTPaymentScheduleResponse
from swagger_client.models.post_payment_schedules_each import POSTPaymentSchedulesEach
from swagger_client.models.post_payment_schedules_request import POSTPaymentSchedulesRequest
from swagger_client.models.post_payment_schedules_response import POSTPaymentSchedulesResponse
from swagger_client.models.post_preview_billing_adjustment_request_type import POSTPreviewBillingAdjustmentRequestType
from swagger_client.models.post_price_book_item_interval_price import POSTPriceBookItemIntervalPrice
from swagger_client.models.post_price_book_item_request import POSTPriceBookItemRequest
from swagger_client.models.post_price_book_item_tier import POSTPriceBookItemTier
from swagger_client.models.post_public_email_template_request import POSTPublicEmailTemplateRequest
from swagger_client.models.post_public_notification_definition_request import POSTPublicNotificationDefinitionRequest
from swagger_client.models.post_public_notification_definition_request_callout import POSTPublicNotificationDefinitionRequestCallout
from swagger_client.models.post_public_notification_definition_request_filter_rule import POSTPublicNotificationDefinitionRequestFilterRule
from swagger_client.models.postrsa_signature_response_type import POSTRSASignatureResponseType
from swagger_client.models.postrsa_signature_type import POSTRSASignatureType
from swagger_client.models.post_reconcile_refund_request import POSTReconcileRefundRequest
from swagger_client.models.post_reconcile_refund_response import POSTReconcileRefundResponse
from swagger_client.models.post_reconcile_refund_response_finance_information import POSTReconcileRefundResponseFinanceInformation
from swagger_client.models.post_reject_payment_request import POSTRejectPaymentRequest
from swagger_client.models.post_reject_payment_response import POSTRejectPaymentResponse
from swagger_client.models.post_resend_callout_notifications import POSTResendCalloutNotifications
from swagger_client.models.post_resend_email_notifications import POSTResendEmailNotifications
from swagger_client.models.post_retry_payment_schedule_item_info import POSTRetryPaymentScheduleItemInfo
from swagger_client.models.post_retry_payment_schedule_item_request import POSTRetryPaymentScheduleItemRequest
from swagger_client.models.post_retry_payment_schedule_item_response import POSTRetryPaymentScheduleItemResponse
from swagger_client.models.post_reverse_payment_request import POSTReversePaymentRequest
from swagger_client.models.post_reverse_payment_response import POSTReversePaymentResponse
from swagger_client.models.postsc_create_type import POSTScCreateType
from swagger_client.models.post_schedule_item_type import POSTScheduleItemType
from swagger_client.models.post_sequence_set_request import POSTSequenceSetRequest
from swagger_client.models.post_sequence_sets_request import POSTSequenceSetsRequest
from swagger_client.models.post_sequence_sets_response import POSTSequenceSetsResponse
from swagger_client.models.post_settle_payment_request import POSTSettlePaymentRequest
from swagger_client.models.post_settle_payment_response import POSTSettlePaymentResponse
from swagger_client.models.post_srp_create_type import POSTSrpCreateType
from swagger_client.models.post_subscription_cancellation_response_type import POSTSubscriptionCancellationResponseType
from swagger_client.models.post_subscription_cancellation_type import POSTSubscriptionCancellationType
from swagger_client.models.post_subscription_preview_credit_memo_items_type import POSTSubscriptionPreviewCreditMemoItemsType
from swagger_client.models.post_subscription_preview_invoice_items_type import POSTSubscriptionPreviewInvoiceItemsType
from swagger_client.models.post_subscription_preview_response_type import POSTSubscriptionPreviewResponseType
from swagger_client.models.post_subscription_preview_response_type_charge_metrics import POSTSubscriptionPreviewResponseTypeChargeMetrics
from swagger_client.models.post_subscription_preview_response_type_credit_memo import POSTSubscriptionPreviewResponseTypeCreditMemo
from swagger_client.models.post_subscription_preview_response_type_invoice import POSTSubscriptionPreviewResponseTypeInvoice
from swagger_client.models.post_subscription_preview_taxation_items_type import POSTSubscriptionPreviewTaxationItemsType
from swagger_client.models.post_subscription_preview_type import POSTSubscriptionPreviewType
from swagger_client.models.post_subscription_preview_type_preview_account_info import POSTSubscriptionPreviewTypePreviewAccountInfo
from swagger_client.models.post_subscription_response_type import POSTSubscriptionResponseType
from swagger_client.models.post_subscription_type import POSTSubscriptionType
from swagger_client.models.post_taxation_item_for_cm_type import POSTTaxationItemForCMType
from swagger_client.models.post_taxation_item_for_dm_type import POSTTaxationItemForDMType
from swagger_client.models.post_taxation_item_list import POSTTaxationItemList
from swagger_client.models.post_taxation_item_list_for_cm_type import POSTTaxationItemListForCMType
from swagger_client.models.post_taxation_item_list_for_dm_type import POSTTaxationItemListForDMType
from swagger_client.models.post_taxation_item_type_for_invoice import POSTTaxationItemTypeForInvoice
from swagger_client.models.post_tier_type import POSTTierType
from swagger_client.models.post_upload_file_response import POSTUploadFileResponse
from swagger_client.models.post_usage_response_type import POSTUsageResponseType
from swagger_client.models.post_void_authorize import POSTVoidAuthorize
from swagger_client.models.post_void_authorize_response import POSTVoidAuthorizeResponse
from swagger_client.models.post_workflow_definition_import_request import POSTWorkflowDefinitionImportRequest
from swagger_client.models.pos_tor_put_catalog_group_add_product_rate_plan import POSTorPUTCatalogGroupAddProductRatePlan
from swagger_client.models.put_account_type import PUTAccountType
from swagger_client.models.put_account_type_bill_to_contact import PUTAccountTypeBillToContact
from swagger_client.models.put_account_type_sold_to_contact import PUTAccountTypeSoldToContact
from swagger_client.models.put_accounting_code_type import PUTAccountingCodeType
from swagger_client.models.put_accounting_period_type import PUTAccountingPeriodType
from swagger_client.models.put_attachment_type import PUTAttachmentType
from swagger_client.models.put_basic_summary_journal_entry_type import PUTBasicSummaryJournalEntryType
from swagger_client.models.put_batch_debit_memos_request import PUTBatchDebitMemosRequest
from swagger_client.models.put_bulk_credit_memos_request_type import PUTBulkCreditMemosRequestType
from swagger_client.models.put_bulk_debit_memos_request_type import PUTBulkDebitMemosRequestType
from swagger_client.models.put_cancel_payment_schedule_request import PUTCancelPaymentScheduleRequest
from swagger_client.models.put_catalog_group import PUTCatalogGroup
from swagger_client.models.put_catalog_group_remove_product_rate_plan import PUTCatalogGroupRemoveProductRatePlan
from swagger_client.models.put_contact_type import PUTContactType
from swagger_client.models.put_credit_memo_item_type import PUTCreditMemoItemType
from swagger_client.models.put_credit_memo_type import PUTCreditMemoType
from swagger_client.models.put_credit_memo_write_off import PUTCreditMemoWriteOff
from swagger_client.models.put_credit_memo_write_off_response_type import PUTCreditMemoWriteOffResponseType
from swagger_client.models.put_credit_memo_write_off_response_type_debit_memo import PUTCreditMemoWriteOffResponseTypeDebitMemo
from swagger_client.models.put_credit_memos_with_id_type import PUTCreditMemosWithIdType
from swagger_client.models.put_debit_memo_item_type import PUTDebitMemoItemType
from swagger_client.models.put_debit_memo_type import PUTDebitMemoType
from swagger_client.models.put_debit_memo_with_id_type import PUTDebitMemoWithIdType
from swagger_client.models.put_delete_subscription_response_type import PUTDeleteSubscriptionResponseType
from swagger_client.models.put_journal_entry_item_type import PUTJournalEntryItemType
from swagger_client.models.put_order_action_trigger_dates_request_type import PUTOrderActionTriggerDatesRequestType
from swagger_client.models.put_order_action_trigger_dates_request_type_charges import PUTOrderActionTriggerDatesRequestTypeCharges
from swagger_client.models.put_order_action_trigger_dates_request_type_order_actions import PUTOrderActionTriggerDatesRequestTypeOrderActions
from swagger_client.models.put_order_action_trigger_dates_request_type_subscriptions import PUTOrderActionTriggerDatesRequestTypeSubscriptions
from swagger_client.models.put_order_action_trigger_dates_request_type_trigger_dates import PUTOrderActionTriggerDatesRequestTypeTriggerDates
from swagger_client.models.put_order_actions_request_type import PUTOrderActionsRequestType
from swagger_client.models.put_order_line_item_request_type import PUTOrderLineItemRequestType
from swagger_client.models.put_order_patch_request_type import PUTOrderPatchRequestType
from swagger_client.models.put_order_patch_request_type_order_actions import PUTOrderPatchRequestTypeOrderActions
from swagger_client.models.put_order_patch_request_type_subscriptions import PUTOrderPatchRequestTypeSubscriptions
from swagger_client.models.put_order_request_type import PUTOrderRequestType
from swagger_client.models.put_order_trigger_dates_response_type import PUTOrderTriggerDatesResponseType
from swagger_client.models.put_order_trigger_dates_response_type_subscriptions import PUTOrderTriggerDatesResponseTypeSubscriptions
from swagger_client.models.putpm_account_holder_info import PUTPMAccountHolderInfo
from swagger_client.models.putpm_credit_card_info import PUTPMCreditCardInfo
from swagger_client.models.put_payment_method_object_custom_fields import PUTPaymentMethodObjectCustomFields
from swagger_client.models.put_payment_method_request import PUTPaymentMethodRequest
from swagger_client.models.put_payment_method_response import PUTPaymentMethodResponse
from swagger_client.models.put_payment_run_request import PUTPaymentRunRequest
from swagger_client.models.put_payment_schedule_item_request import PUTPaymentScheduleItemRequest
from swagger_client.models.put_payment_schedule_item_response import PUTPaymentScheduleItemResponse
from swagger_client.models.put_payment_schedule_request import PUTPaymentScheduleRequest
from swagger_client.models.put_preview_payment_schedule_request import PUTPreviewPaymentScheduleRequest
from swagger_client.models.put_price_book_item_request import PUTPriceBookItemRequest
from swagger_client.models.put_public_email_template_request import PUTPublicEmailTemplateRequest
from swagger_client.models.put_public_notification_definition_request import PUTPublicNotificationDefinitionRequest
from swagger_client.models.put_public_notification_definition_request_callout import PUTPublicNotificationDefinitionRequestCallout
from swagger_client.models.put_public_notification_definition_request_filter_rule import PUTPublicNotificationDefinitionRequestFilterRule
from swagger_client.models.put_publish_open_payment_method_type_response import PUTPublishOpenPaymentMethodTypeResponse
from swagger_client.models.put_refund_type import PUTRefundType
from swagger_client.models.put_renew_subscription_response_type import PUTRenewSubscriptionResponseType
from swagger_client.models.put_renew_subscription_type import PUTRenewSubscriptionType
from swagger_client.models.put_revpro_acc_code_response import PUTRevproAccCodeResponse
from swagger_client.models.putsc_add_type import PUTScAddType
from swagger_client.models.putsc_update_type import PUTScUpdateType
from swagger_client.models.put_sequence_set_request import PUTSequenceSetRequest
from swagger_client.models.put_sequence_set_response import PUTSequenceSetResponse
from swagger_client.models.put_skip_payment_schedule_item_response import PUTSkipPaymentScheduleItemResponse
from swagger_client.models.put_srp_add_type import PUTSrpAddType
from swagger_client.models.put_srp_change_type import PUTSrpChangeType
from swagger_client.models.put_srp_remove_type import PUTSrpRemoveType
from swagger_client.models.put_srp_update_type import PUTSrpUpdateType
from swagger_client.models.put_subscription_patch_request_type import PUTSubscriptionPatchRequestType
from swagger_client.models.put_subscription_patch_request_type_charges import PUTSubscriptionPatchRequestTypeCharges
from swagger_client.models.put_subscription_patch_request_type_rate_plans import PUTSubscriptionPatchRequestTypeRatePlans
from swagger_client.models.put_subscription_patch_specific_version_request_type import PUTSubscriptionPatchSpecificVersionRequestType
from swagger_client.models.put_subscription_patch_specific_version_request_type_charges import PUTSubscriptionPatchSpecificVersionRequestTypeCharges
from swagger_client.models.put_subscription_patch_specific_version_request_type_rate_plans import PUTSubscriptionPatchSpecificVersionRequestTypeRatePlans
from swagger_client.models.put_subscription_preview_invoice_items_type import PUTSubscriptionPreviewInvoiceItemsType
from swagger_client.models.put_subscription_response_type import PUTSubscriptionResponseType
from swagger_client.models.put_subscription_response_type_charge_metrics import PUTSubscriptionResponseTypeChargeMetrics
from swagger_client.models.put_subscription_response_type_credit_memo import PUTSubscriptionResponseTypeCreditMemo
from swagger_client.models.put_subscription_response_type_invoice import PUTSubscriptionResponseTypeInvoice
from swagger_client.models.put_subscription_resume_response_type import PUTSubscriptionResumeResponseType
from swagger_client.models.put_subscription_resume_type import PUTSubscriptionResumeType
from swagger_client.models.put_subscription_suspend_response_type import PUTSubscriptionSuspendResponseType
from swagger_client.models.put_subscription_suspend_type import PUTSubscriptionSuspendType
from swagger_client.models.put_subscription_type import PUTSubscriptionType
from swagger_client.models.put_taxation_item_type import PUTTaxationItemType
from swagger_client.models.put_update_invoice_schedule_request import PUTUpdateInvoiceScheduleRequest
from swagger_client.models.put_update_open_payment_method_type_request import PUTUpdateOpenPaymentMethodTypeRequest
from swagger_client.models.put_update_open_payment_method_type_response import PUTUpdateOpenPaymentMethodTypeResponse
from swagger_client.models.put_verify_payment_method_response_type import PUTVerifyPaymentMethodResponseType
from swagger_client.models.put_verify_payment_method_type import PUTVerifyPaymentMethodType
from swagger_client.models.put_write_off_invoice_request import PUTWriteOffInvoiceRequest
from swagger_client.models.put_write_off_invoice_response import PUTWriteOffInvoiceResponse
from swagger_client.models.put_write_off_invoice_response_credit_memo import PUTWriteOffInvoiceResponseCreditMemo
from swagger_client.models.payment_collection_response_type import PaymentCollectionResponseType
from swagger_client.models.payment_data import PaymentData
from swagger_client.models.payment_debit_memo_application_apply_request_type import PaymentDebitMemoApplicationApplyRequestType
from swagger_client.models.payment_debit_memo_application_create_request_type import PaymentDebitMemoApplicationCreateRequestType
from swagger_client.models.payment_debit_memo_application_item_apply_request_type import PaymentDebitMemoApplicationItemApplyRequestType
from swagger_client.models.payment_debit_memo_application_item_create_request_type import PaymentDebitMemoApplicationItemCreateRequestType
from swagger_client.models.payment_debit_memo_application_item_unapply_request_type import PaymentDebitMemoApplicationItemUnapplyRequestType
from swagger_client.models.payment_debit_memo_application_unapply_request_type import PaymentDebitMemoApplicationUnapplyRequestType
from swagger_client.models.payment_entity_prefix import PaymentEntityPrefix
from swagger_client.models.payment_invoice_application_apply_request_type import PaymentInvoiceApplicationApplyRequestType
from swagger_client.models.payment_invoice_application_create_request_type import PaymentInvoiceApplicationCreateRequestType
from swagger_client.models.payment_invoice_application_item_apply_request_type import PaymentInvoiceApplicationItemApplyRequestType
from swagger_client.models.payment_invoice_application_item_create_request_type import PaymentInvoiceApplicationItemCreateRequestType
from swagger_client.models.payment_invoice_application_item_unapply_request_type import PaymentInvoiceApplicationItemUnapplyRequestType
from swagger_client.models.payment_invoice_application_unapply_request_type import PaymentInvoiceApplicationUnapplyRequestType
from swagger_client.models.payment_method_object_custom_fields import PaymentMethodObjectCustomFields
from swagger_client.models.payment_method_object_custom_fields_for_account import PaymentMethodObjectCustomFieldsForAccount
from swagger_client.models.payment_object_custom_fields import PaymentObjectCustomFields
from swagger_client.models.payment_object_ns_fields import PaymentObjectNSFields
from swagger_client.models.payment_run_statistic import PaymentRunStatistic
from swagger_client.models.payment_schedule_common_response import PaymentScheduleCommonResponse
from swagger_client.models.payment_schedule_custom_fields import PaymentScheduleCustomFields
from swagger_client.models.payment_schedule_item_common import PaymentScheduleItemCommon
from swagger_client.models.payment_schedule_item_common_response import PaymentScheduleItemCommonResponse
from swagger_client.models.payment_schedule_item_custom_fields import PaymentScheduleItemCustomFields
from swagger_client.models.payment_schedule_payment_option_fields import PaymentSchedulePaymentOptionFields
from swagger_client.models.payment_schedule_payment_option_fields_detail import PaymentSchedulePaymentOptionFieldsDetail
from swagger_client.models.payment_volume_summary_record import PaymentVolumeSummaryRecord
from swagger_client.models.payment_with_custom_rates_type import PaymentWithCustomRatesType
from swagger_client.models.post_batch_invoice_item_response import PostBatchInvoiceItemResponse
from swagger_client.models.post_batch_invoice_response import PostBatchInvoiceResponse
from swagger_client.models.post_batch_invoices_type import PostBatchInvoicesType
from swagger_client.models.post_billing_preview_param import PostBillingPreviewParam
from swagger_client.models.post_billing_preview_run_param import PostBillingPreviewRunParam
from swagger_client.models.post_credit_memo_email_request_type import PostCreditMemoEmailRequestType
from swagger_client.models.post_custom_object_definition_field_definition_request import PostCustomObjectDefinitionFieldDefinitionRequest
from swagger_client.models.post_custom_object_definition_fields_definition_request import PostCustomObjectDefinitionFieldsDefinitionRequest
from swagger_client.models.post_custom_object_definitions_request import PostCustomObjectDefinitionsRequest
from swagger_client.models.post_custom_object_definitions_request_definition import PostCustomObjectDefinitionsRequestDefinition
from swagger_client.models.post_custom_object_definitions_request_definitions import PostCustomObjectDefinitionsRequestDefinitions
from swagger_client.models.post_custom_object_records_request import PostCustomObjectRecordsRequest
from swagger_client.models.post_custom_object_records_response import PostCustomObjectRecordsResponse
from swagger_client.models.post_debit_memo_email_type import PostDebitMemoEmailType
from swagger_client.models.post_discount_item_type import PostDiscountItemType
from swagger_client.models.post_event_trigger_request import PostEventTriggerRequest
from swagger_client.models.post_fulfillment_items_request_type import PostFulfillmentItemsRequestType
from swagger_client.models.post_fulfillment_items_response_type import PostFulfillmentItemsResponseType
from swagger_client.models.post_fulfillment_items_response_type_fulfillment_items import PostFulfillmentItemsResponseTypeFulfillmentItems
from swagger_client.models.post_fulfillments_request_type import PostFulfillmentsRequestType
from swagger_client.models.post_fulfillments_response_type import PostFulfillmentsResponseType
from swagger_client.models.post_fulfillments_response_type_fulfillments import PostFulfillmentsResponseTypeFulfillments
from swagger_client.models.post_generate_billing_document_type import PostGenerateBillingDocumentType
from swagger_client.models.post_invoice_email_request_type import PostInvoiceEmailRequestType
from swagger_client.models.post_invoice_item_type import PostInvoiceItemType
from swagger_client.models.post_invoice_response import PostInvoiceResponse
from swagger_client.models.post_invoice_type import PostInvoiceType
from swagger_client.models.post_non_ref_refund_type import PostNonRefRefundType
from swagger_client.models.post_order_account_payment_method import PostOrderAccountPaymentMethod
from swagger_client.models.post_order_line_item_update_type import PostOrderLineItemUpdateType
from swagger_client.models.post_order_line_items_request_type import PostOrderLineItemsRequestType
from swagger_client.models.post_order_preview_response_type import PostOrderPreviewResponseType
from swagger_client.models.post_order_response_type import PostOrderResponseType
from swagger_client.models.post_order_response_type_refunds import PostOrderResponseTypeRefunds
from swagger_client.models.post_order_response_type_subscriptions import PostOrderResponseTypeSubscriptions
from swagger_client.models.post_order_response_type_write_off import PostOrderResponseTypeWriteOff
from swagger_client.models.post_refund_type import PostRefundType
from swagger_client.models.post_refundwith_auto_unapply_type import PostRefundwithAutoUnapplyType
from swagger_client.models.post_scheduled_event_request import PostScheduledEventRequest
from swagger_client.models.post_scheduled_event_request_parameters import PostScheduledEventRequestParameters
from swagger_client.models.post_taxation_item_type import PostTaxationItemType
from swagger_client.models.preview_account_info import PreviewAccountInfo
from swagger_client.models.preview_contact_info import PreviewContactInfo
from swagger_client.models.preview_options import PreviewOptions
from swagger_client.models.preview_order_charge_override import PreviewOrderChargeOverride
from swagger_client.models.preview_order_charge_update import PreviewOrderChargeUpdate
from swagger_client.models.preview_order_create_subscription import PreviewOrderCreateSubscription
from swagger_client.models.preview_order_create_subscription_new_subscription_owner_account import PreviewOrderCreateSubscriptionNewSubscriptionOwnerAccount
from swagger_client.models.preview_order_order_action import PreviewOrderOrderAction
from swagger_client.models.preview_order_pricing_update import PreviewOrderPricingUpdate
from swagger_client.models.preview_order_rate_plan_override import PreviewOrderRatePlanOverride
from swagger_client.models.preview_order_rate_plan_update import PreviewOrderRatePlanUpdate
from swagger_client.models.preview_order_trigger_params import PreviewOrderTriggerParams
from swagger_client.models.preview_result import PreviewResult
from swagger_client.models.preview_result_charge_metrics import PreviewResultChargeMetrics
from swagger_client.models.preview_result_credit_memos import PreviewResultCreditMemos
from swagger_client.models.preview_result_invoices import PreviewResultInvoices
from swagger_client.models.preview_result_order_actions import PreviewResultOrderActions
from swagger_client.models.preview_result_order_delta_metrics import PreviewResultOrderDeltaMetrics
from swagger_client.models.preview_result_order_metrics import PreviewResultOrderMetrics
from swagger_client.models.price_change_params import PriceChangeParams
from swagger_client.models.price_interval_with_price import PriceIntervalWithPrice
from swagger_client.models.price_interval_with_tiers import PriceIntervalWithTiers
from swagger_client.models.pricing_update import PricingUpdate
from swagger_client.models.pricing_update_recurring_delivery import PricingUpdateRecurringDelivery
from swagger_client.models.processing_options import ProcessingOptions
from swagger_client.models.processing_options_orders import ProcessingOptionsOrders
from swagger_client.models.processing_options_orders_async import ProcessingOptionsOrdersAsync
from swagger_client.models.processing_options_orders_billing_options import ProcessingOptionsOrdersBillingOptions
from swagger_client.models.processing_options_orders_electronic_payment_options import ProcessingOptionsOrdersElectronicPaymentOptions
from swagger_client.models.processing_options_orders_write_off_behavior import ProcessingOptionsOrdersWriteOffBehavior
from swagger_client.models.processing_options_orders_write_off_behavior_finance_information import ProcessingOptionsOrdersWriteOffBehaviorFinanceInformation
from swagger_client.models.product_feature_object_custom_fields import ProductFeatureObjectCustomFields
from swagger_client.models.product_object_custom_fields import ProductObjectCustomFields
from swagger_client.models.product_object_ns_fields import ProductObjectNSFields
from swagger_client.models.product_rate_plan_charge_object_custom_fields import ProductRatePlanChargeObjectCustomFields
from swagger_client.models.product_rate_plan_charge_object_ns_fields import ProductRatePlanChargeObjectNSFields
from swagger_client.models.product_rate_plan_object_custom_fields import ProductRatePlanObjectCustomFields
from swagger_client.models.product_rate_plan_object_ns_fields import ProductRatePlanObjectNSFields
from swagger_client.models.proxy_actioncreate_request import ProxyActioncreateRequest
from swagger_client.models.proxy_actiondelete_request import ProxyActiondeleteRequest
from swagger_client.models.proxy_actionquery_more_request import ProxyActionqueryMoreRequest
from swagger_client.models.proxy_actionquery_more_request_conf import ProxyActionqueryMoreRequestConf
from swagger_client.models.proxy_actionquery_more_response import ProxyActionqueryMoreResponse
from swagger_client.models.proxy_actionquery_request import ProxyActionqueryRequest
from swagger_client.models.proxy_actionquery_response import ProxyActionqueryResponse
from swagger_client.models.proxy_actionupdate_request import ProxyActionupdateRequest
from swagger_client.models.proxy_bad_request_response import ProxyBadRequestResponse
from swagger_client.models.proxy_bad_request_response_errors import ProxyBadRequestResponseErrors
from swagger_client.models.proxy_create_or_modify_delivery_schedule import ProxyCreateOrModifyDeliverySchedule
from swagger_client.models.proxy_create_or_modify_product_rate_plan_charge_charge_model_configuration import ProxyCreateOrModifyProductRatePlanChargeChargeModelConfiguration
from swagger_client.models.proxy_create_or_modify_product_rate_plan_charge_charge_model_configuration_item import ProxyCreateOrModifyProductRatePlanChargeChargeModelConfigurationItem
from swagger_client.models.proxy_create_or_modify_product_rate_plan_charge_tier_data import ProxyCreateOrModifyProductRatePlanChargeTierData
from swagger_client.models.proxy_create_or_modify_product_rate_plan_charge_tier_data_product_rate_plan_charge_tier import ProxyCreateOrModifyProductRatePlanChargeTierDataProductRatePlanChargeTier
from swagger_client.models.proxy_create_or_modify_response import ProxyCreateOrModifyResponse
from swagger_client.models.proxy_create_product import ProxyCreateProduct
from swagger_client.models.proxy_create_product_rate_plan import ProxyCreateProductRatePlan
from swagger_client.models.proxy_create_product_rate_plan_charge import ProxyCreateProductRatePlanCharge
from swagger_client.models.proxy_create_taxation_item import ProxyCreateTaxationItem
from swagger_client.models.proxy_create_usage import ProxyCreateUsage
from swagger_client.models.proxy_delete_response import ProxyDeleteResponse
from swagger_client.models.proxy_get_import import ProxyGetImport
from swagger_client.models.proxy_get_payment_method_snapshot import ProxyGetPaymentMethodSnapshot
from swagger_client.models.proxy_get_payment_method_transaction_log import ProxyGetPaymentMethodTransactionLog
from swagger_client.models.proxy_get_payment_transaction_log import ProxyGetPaymentTransactionLog
from swagger_client.models.proxy_get_product import ProxyGetProduct
from swagger_client.models.proxy_get_product_rate_plan import ProxyGetProductRatePlan
from swagger_client.models.proxy_get_product_rate_plan_charge import ProxyGetProductRatePlanCharge
from swagger_client.models.proxy_get_product_rate_plan_charge_tier import ProxyGetProductRatePlanChargeTier
from swagger_client.models.proxy_get_usage import ProxyGetUsage
from swagger_client.models.proxy_modify_product import ProxyModifyProduct
from swagger_client.models.proxy_modify_product_rate_plan import ProxyModifyProductRatePlan
from swagger_client.models.proxy_modify_product_rate_plan_charge import ProxyModifyProductRatePlanCharge
from swagger_client.models.proxy_modify_product_rate_plan_charge_tier import ProxyModifyProductRatePlanChargeTier
from swagger_client.models.proxy_modify_usage import ProxyModifyUsage
from swagger_client.models.proxy_no_data_response import ProxyNoDataResponse
from swagger_client.models.proxy_post_import import ProxyPostImport
from swagger_client.models.proxy_unauthorized_response import ProxyUnauthorizedResponse
from swagger_client.models.put_batch_invoice_type import PutBatchInvoiceType
from swagger_client.models.put_credit_memo_tax_item_type import PutCreditMemoTaxItemType
from swagger_client.models.put_debit_memo_tax_item_type import PutDebitMemoTaxItemType
from swagger_client.models.put_discount_item_type import PutDiscountItemType
from swagger_client.models.put_event_trigger_request import PutEventTriggerRequest
from swagger_client.models.put_event_trigger_request_event_type import PutEventTriggerRequestEventType
from swagger_client.models.put_fulfillment_item_request_type import PutFulfillmentItemRequestType
from swagger_client.models.put_fulfillment_request_type import PutFulfillmentRequestType
from swagger_client.models.put_invoice_item_type import PutInvoiceItemType
from swagger_client.models.put_invoice_response_type import PutInvoiceResponseType
from swagger_client.models.put_invoice_type import PutInvoiceType
from swagger_client.models.put_order_cancel_response import PutOrderCancelResponse
from swagger_client.models.put_order_line_item_response_type import PutOrderLineItemResponseType
from swagger_client.models.put_order_line_item_update_type import PutOrderLineItemUpdateType
from swagger_client.models.put_reverse_credit_memo_response_type import PutReverseCreditMemoResponseType
from swagger_client.models.put_reverse_credit_memo_response_type_credit_memo import PutReverseCreditMemoResponseTypeCreditMemo
from swagger_client.models.put_reverse_credit_memo_response_type_debit_memo import PutReverseCreditMemoResponseTypeDebitMemo
from swagger_client.models.put_reverse_credit_memo_type import PutReverseCreditMemoType
from swagger_client.models.put_reverse_invoice_response_type import PutReverseInvoiceResponseType
from swagger_client.models.put_reverse_invoice_response_type_credit_memo import PutReverseInvoiceResponseTypeCreditMemo
from swagger_client.models.put_reverse_invoice_response_type_debit_memo import PutReverseInvoiceResponseTypeDebitMemo
from swagger_client.models.put_reverse_invoice_type import PutReverseInvoiceType
from swagger_client.models.put_scheduled_event_request import PutScheduledEventRequest
from swagger_client.models.put_tasks_request import PutTasksRequest
from swagger_client.models.query_custom_object_records_response import QueryCustomObjectRecordsResponse
from swagger_client.models.quote_object_fields import QuoteObjectFields
from swagger_client.models.ramp_charge_request import RampChargeRequest
from swagger_client.models.ramp_charge_response import RampChargeResponse
from swagger_client.models.ramp_interval_charge_delta_metrics import RampIntervalChargeDeltaMetrics
from swagger_client.models.ramp_interval_charge_delta_metrics_delta_mrr import RampIntervalChargeDeltaMetricsDeltaMrr
from swagger_client.models.ramp_interval_charge_delta_metrics_delta_quantity import RampIntervalChargeDeltaMetricsDeltaQuantity
from swagger_client.models.ramp_interval_charge_metrics import RampIntervalChargeMetrics
from swagger_client.models.ramp_interval_charge_metrics_mrr import RampIntervalChargeMetricsMrr
from swagger_client.models.ramp_interval_metrics import RampIntervalMetrics
from swagger_client.models.ramp_interval_request import RampIntervalRequest
from swagger_client.models.ramp_interval_response import RampIntervalResponse
from swagger_client.models.ramp_metrics import RampMetrics
from swagger_client.models.ramp_request import RampRequest
from swagger_client.models.ramp_response import RampResponse
from swagger_client.models.rate_plan import RatePlan
from swagger_client.models.rate_plan_charge_object_custom_fields import RatePlanChargeObjectCustomFields
from swagger_client.models.rate_plan_feature_override import RatePlanFeatureOverride
from swagger_client.models.rate_plan_feature_override_custom_fields import RatePlanFeatureOverrideCustomFields
from swagger_client.models.rate_plan_object_custom_fields import RatePlanObjectCustomFields
from swagger_client.models.rate_plan_override import RatePlanOverride
from swagger_client.models.rate_plan_update import RatePlanUpdate
from swagger_client.models.rate_plans import RatePlans
from swagger_client.models.recurring_delivery_pricing_override import RecurringDeliveryPricingOverride
from swagger_client.models.recurring_delivery_pricing_update import RecurringDeliveryPricingUpdate
from swagger_client.models.recurring_flat_fee_pricing_override import RecurringFlatFeePricingOverride
from swagger_client.models.recurring_flat_fee_pricing_update import RecurringFlatFeePricingUpdate
from swagger_client.models.recurring_per_unit_pricing_override import RecurringPerUnitPricingOverride
from swagger_client.models.recurring_per_unit_pricing_update import RecurringPerUnitPricingUpdate
from swagger_client.models.recurring_tiered_pricing_override import RecurringTieredPricingOverride
from swagger_client.models.recurring_tiered_pricing_update import RecurringTieredPricingUpdate
from swagger_client.models.recurring_volume_pricing_override import RecurringVolumePricingOverride
from swagger_client.models.recurring_volume_pricing_update import RecurringVolumePricingUpdate
from swagger_client.models.refund_credit_memo_item_type import RefundCreditMemoItemType
from swagger_client.models.refund_entity_prefix import RefundEntityPrefix
from swagger_client.models.refund_object_custom_fields import RefundObjectCustomFields
from swagger_client.models.refund_object_ns_fields import RefundObjectNSFields
from swagger_client.models.refund_part_response_type import RefundPartResponseType
from swagger_client.models.refund_part_response_typewith_success import RefundPartResponseTypewithSuccess
from swagger_client.models.remove_product import RemoveProduct
from swagger_client.models.renew_subscription import RenewSubscription
from swagger_client.models.renewal_term import RenewalTerm
from swagger_client.models.request import Request
from swagger_client.models.request1 import Request1
from swagger_client.models.resend_callout_notifications_failed_response import ResendCalloutNotificationsFailedResponse
from swagger_client.models.resend_email_notifications_failed_response import ResendEmailNotificationsFailedResponse
from swagger_client.models.revpro_accounting_codes import RevproAccountingCodes
from swagger_client.models.save_result import SaveResult
from swagger_client.models.schedule_items_response import ScheduleItemsResponse
from swagger_client.models.setting_component_key_value import SettingComponentKeyValue
from swagger_client.models.setting_item_http_operation import SettingItemHttpOperation
from swagger_client.models.setting_item_http_request_parameter import SettingItemHttpRequestParameter
from swagger_client.models.setting_item_with_operations_information import SettingItemWithOperationsInformation
from swagger_client.models.setting_source_component_response import SettingSourceComponentResponse
from swagger_client.models.setting_value_request import SettingValueRequest
from swagger_client.models.setting_value_response import SettingValueResponse
from swagger_client.models.setting_value_response_wrapper import SettingValueResponseWrapper
from swagger_client.models.settings_batch_request import SettingsBatchRequest
from swagger_client.models.settings_batch_response import SettingsBatchResponse
from swagger_client.models.sign_up_create_pm_pay_pal_ec_pay_pal_native_ec import SignUpCreatePMPayPalECPayPalNativeEC
from swagger_client.models.sign_up_create_payment_method_cardholder_info import SignUpCreatePaymentMethodCardholderInfo
from swagger_client.models.sign_up_create_payment_method_common import SignUpCreatePaymentMethodCommon
from swagger_client.models.sign_up_create_payment_method_credit_card import SignUpCreatePaymentMethodCreditCard
from swagger_client.models.sign_up_create_payment_method_credit_card_reference_transaction import SignUpCreatePaymentMethodCreditCardReferenceTransaction
from swagger_client.models.sign_up_create_payment_method_pay_pal_adaptive import SignUpCreatePaymentMethodPayPalAdaptive
from swagger_client.models.sign_up_payment_method import SignUpPaymentMethod
from swagger_client.models.sign_up_payment_method_object_custom_fields import SignUpPaymentMethodObjectCustomFields
from swagger_client.models.sign_up_request import SignUpRequest
from swagger_client.models.sign_up_response import SignUpResponse
from swagger_client.models.sign_up_response_reasons import SignUpResponseReasons
from swagger_client.models.sign_up_tax_info import SignUpTaxInfo
from swagger_client.models.sold_to_contact import SoldToContact
from swagger_client.models.sold_to_contact_post_order import SoldToContactPostOrder
from swagger_client.models.submit_batch_query_request import SubmitBatchQueryRequest
from swagger_client.models.submit_batch_query_response import SubmitBatchQueryResponse
from swagger_client.models.submit_data_query_request import SubmitDataQueryRequest
from swagger_client.models.submit_data_query_request_output import SubmitDataQueryRequestOutput
from swagger_client.models.submit_data_query_response import SubmitDataQueryResponse
from swagger_client.models.subscribe_to_product import SubscribeToProduct
from swagger_client.models.subscription_data import SubscriptionData
from swagger_client.models.subscription_object_custom_fields import SubscriptionObjectCustomFields
from swagger_client.models.subscription_object_ns_fields import SubscriptionObjectNSFields
from swagger_client.models.subscription_object_qt_fields import SubscriptionObjectQTFields
from swagger_client.models.subscription_offer_object_custom_fields import SubscriptionOfferObjectCustomFields
from swagger_client.models.system_health_error_response import SystemHealthErrorResponse
from swagger_client.models.task import Task
from swagger_client.models.tasks_response import TasksResponse
from swagger_client.models.tasks_response_pagination import TasksResponsePagination
from swagger_client.models.tax_info import TaxInfo
from swagger_client.models.taxation_item_object_custom_fields import TaxationItemObjectCustomFields
from swagger_client.models.template_detail_response import TemplateDetailResponse
from swagger_client.models.template_migration_client_request import TemplateMigrationClientRequest
from swagger_client.models.template_response import TemplateResponse
from swagger_client.models.term_info import TermInfo
from swagger_client.models.term_info_initial_term import TermInfoInitialTerm
from swagger_client.models.term_info_renewal_terms import TermInfoRenewalTerms
from swagger_client.models.terms_and_conditions import TermsAndConditions
from swagger_client.models.time_sliced_elp_net_metrics import TimeSlicedElpNetMetrics
from swagger_client.models.time_sliced_metrics import TimeSlicedMetrics
from swagger_client.models.time_sliced_net_metrics import TimeSlicedNetMetrics
from swagger_client.models.time_sliced_tcb_net_metrics import TimeSlicedTcbNetMetrics
from swagger_client.models.token_response import TokenResponse
from swagger_client.models.transfer_payment_type import TransferPaymentType
from swagger_client.models.trigger_date import TriggerDate
from swagger_client.models.trigger_params import TriggerParams
from swagger_client.models.unapply_credit_memo_type import UnapplyCreditMemoType
from swagger_client.models.unapply_payment_type import UnapplyPaymentType
from swagger_client.models.update_custom_object_cusotm_field import UpdateCustomObjectCusotmField
from swagger_client.models.update_payment_type import UpdatePaymentType
from swagger_client.models.update_schedule_items import UpdateScheduleItems
from swagger_client.models.update_task import UpdateTask
from swagger_client.models.usage import Usage
from swagger_client.models.usage_flat_fee_pricing_override import UsageFlatFeePricingOverride
from swagger_client.models.usage_flat_fee_pricing_update import UsageFlatFeePricingUpdate
from swagger_client.models.usage_object_custom_fields import UsageObjectCustomFields
from swagger_client.models.usage_overage_pricing_override import UsageOveragePricingOverride
from swagger_client.models.usage_overage_pricing_update import UsageOveragePricingUpdate
from swagger_client.models.usage_per_unit_pricing_override import UsagePerUnitPricingOverride
from swagger_client.models.usage_per_unit_pricing_update import UsagePerUnitPricingUpdate
from swagger_client.models.usage_tiered_pricing_override import UsageTieredPricingOverride
from swagger_client.models.usage_tiered_pricing_update import UsageTieredPricingUpdate
from swagger_client.models.usage_tiered_with_overage_pricing_override import UsageTieredWithOveragePricingOverride
from swagger_client.models.usage_tiered_with_overage_pricing_update import UsageTieredWithOveragePricingUpdate
from swagger_client.models.usage_values import UsageValues
from swagger_client.models.usage_volume_pricing_override import UsageVolumePricingOverride
from swagger_client.models.usage_volume_pricing_update import UsageVolumePricingUpdate
from swagger_client.models.usages_response import UsagesResponse
from swagger_client.models.validation_errors import ValidationErrors
from swagger_client.models.validation_reasons import ValidationReasons
from swagger_client.models.workflow import Workflow
from swagger_client.models.workflow_definition import WorkflowDefinition
from swagger_client.models.workflow_definition_active_version import WorkflowDefinitionActiveVersion
from swagger_client.models.workflow_definition_and_versions import WorkflowDefinitionAndVersions
from swagger_client.models.workflow_error import WorkflowError
from swagger_client.models.workflow_instance import WorkflowInstance
from swagger_client.models.z_object import ZObject
from swagger_client.models.z_object_update import ZObjectUpdate
